// tispdDlg.cpp : implementation file
//

#include "stdafx.h"
#include "tispd.h"
#include "tispdDlg.h"
#include "wtypes.h"
#include "TiUserData.h"
#include "afxmt.h"
#include "winuser.h"
#include "LogDlg.h"

#include "AddUserDlg.h"

//oleauto.h
# define IDC_DOWNTXT 1010
# define IDC_UPTXT 1012
#define WM_TRAYICON WM_USER+1
#define NM_MODE 512
int newemuleIN;
int newemuleOUT;
int emuleIN;
int emuleOUT;

#include "ChgSpd.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

static int CALLBACK  SortFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	CtispdDlg* pDlg = (CtispdDlg*)lParamSort;
   //CListCtrl* pListCtrl = (CListCtrl*) lParamSort;
   //CString    strItem1 = pListCtrl->GetItemText(lParam1, 0);
  // CString    strItem2 = pListCtrl->GetItemText(lParam2, 0);
	if(lParam1==10000)
		return 1;
	if(lParam2==10000)
		return -1;
   CString    strItem1 = pDlg->Users[lParam1].UserName_0;
   CString    strItem2 = pDlg->Users[lParam2].UserName_0;
  
	int nRetVal=0;

	
CTime t1(pDlg->Users[lParam1].lastacttime);
	CTime t2(pDlg->Users[lParam2].lastacttime);
//{USERNAME,CONTRACTSPDRXTX,RXMB,TXMB,SLIDER,AVGRXTX,RXTXSPD,LASTACTIVE,MAXCOLUMNS};
	switch(pDlg->SortByCol)
{
case USERNAME: // Last Name
	   strItem1 = pDlg->Users[lParam1].UserName_0;
       strItem2 = pDlg->Users[lParam2].UserName_0;
       nRetVal = -wcscmp(strItem2, strItem1); 
break;

case CONTRACTSPDRXTX:
	if(pDlg->Users[lParam1].RXSPDContract==pDlg->Users[lParam2].RXSPDContract)
		nRetVal = 0;
	else
	if(pDlg->Users[lParam1].RXSPDContract>pDlg->Users[lParam2].RXSPDContract)
		nRetVal = -1;
	else
		nRetVal = 1;
	// First Name
/*nRetVal = strcmp(pData1->pszFirstName,
pData2->pszFirstName);*/
break;

case RXMB: 
			

	if(pDlg->Users[lParam1].RX_20==pDlg->Users[lParam2].RX_20)
			nRetVal = 0;
	else
	if(pDlg->Users[lParam1].RX_20>pDlg->Users[lParam2].RX_20)
		nRetVal = -1;
	else
		nRetVal = 1;
	break;
case TXMB: 
	if(pDlg->Users[lParam1].TX_21==pDlg->Users[lParam2].TX_21)
			nRetVal = 0;
	else
	if(pDlg->Users[lParam1].TX_21>pDlg->Users[lParam2].TX_21)
		nRetVal = -1;
	else
		nRetVal = 1;
	break;
case SLIDER: 
case AVGRXTX:
	if(pDlg->Users[lParam1].AvgRX==pDlg->Users[lParam2].AvgRX)
			nRetVal = 0;
	else
		if(pDlg->Users[lParam1].AvgRX>pDlg->Users[lParam2].AvgRX)
		nRetVal = -1;
	else
		nRetVal = 1;
	break;
case RXTXSPD:
	if(pDlg->Users[lParam1].RXSPD_33==pDlg->Users[lParam2].RXSPD_33)
			nRetVal = 0;
	else
	if(pDlg->Users[lParam1].RXSPD_33>pDlg->Users[lParam2].RXSPD_33)
		nRetVal = -1;
	else
		nRetVal = 1;
	break;
case LASTACTIVE:
	if(t1==t2)
		nRetVal = 0;
	else
		if(t1>t2)
		nRetVal = -1;
	else
		nRetVal = 1;
	break;
case KTRAFF:
	if(pDlg->Users[lParam1].ktraff==pDlg->Users[lParam2].ktraff)
		nRetVal = 0;
	else
		if(pDlg->Users[lParam1].ktraff>pDlg->Users[lParam2].ktraff)
		nRetVal = -1;
	else
		nRetVal = 1;
	break;

case GROUPNAME:
	if(pDlg->Users[lParam1].groupid==pDlg->Users[lParam2].groupid)
		nRetVal = 0;
	else
		if(pDlg->Users[lParam1].groupid>pDlg->Users[lParam2].groupid)
		nRetVal = -1;
	else
		nRetVal = 1;
	break;
case USER_BALANCE:
	if(pDlg->Users[lParam1].Balance_19==pDlg->Users[lParam2].Balance_19)
		nRetVal = 0;
	else
		if(pDlg->Users[lParam1].Balance_19>pDlg->Users[lParam2].Balance_19)
		nRetVal = -1;
	else
		nRetVal = 1;
	break;
	case USERIP: // Last Name
		strItem1 = pDlg->Users[lParam1].IP_24;
       strItem2 = pDlg->Users[lParam2].IP_24;
       nRetVal = -wcscmp(strItem2, strItem1); 
break;
default:
break;
}

	return pDlg->SortWay[pDlg->SortByCol]*nRetVal;

}


void MessageLog(CString& mess,HWND hWnd, int Replacelast=0)
{
	::SendMessage(hWnd,WM_MESSLOG,(LPARAM)Replacelast,(LPARAM)&mess);
}
class CEvent Break,ChangeTarif,ChangeSpeedlim,Stopped,QuitTIspd;
UINT GetUsersFromTI(LPVOID* lp)
{
	
HRESULT hr;
	CtispdDlg *pDlg = (CtispdDlg *)lp;
	CSettDlg *SDlg =&pDlg->SDlg;
if(WaitForSingleObject(Stopped,0)==WAIT_TIMEOUT)
	{
		Break.SetEvent();
		MessageLog(CString("  ..."),pDlg->hWnd,NM_INFO);
		WaitForSingleObject(Stopped,INFINITE);
		MessageLog(CString(" ."),pDlg->hWnd,NM_INFO | NM_OFFLINE);
	}
		Stopped.ResetEvent();
		Break.ResetEvent();





CComPtr<ITrafInspAdmin> pTrafInspAdmin;	
COSERVERINFO csServerInfo = {0L, SDlg->ServerName.GetBuffer(0), 0, 0};
MULTI_QI mqResults = {&IID_ITrafInspAdmin, NULL, 0};
hr = CoInitializeEx(NULL, COINIT_MULTITHREADED);
MessageLog(L" "+SDlg->ServerName,pDlg->hWnd,NM_INFO );

//hr = CoCreateInstanceEx(CLSID_TrafInsp, NULL, CLSCTX_ALL, &csServerInfo, 1, &mqResults);
hr = CoCreateInstanceEx(CLSID_TrafInspAdmin, NULL, CLSCTX_ALL, &csServerInfo, 1, &mqResults);

if (hr!=S_OK)
{
	MessageLog(L"   " + SDlg->ServerName,pDlg->hWnd,CRITICAL_ERROR | NM_OFFLINE);
	AfxMessageBox(L"   " + SDlg->ServerName);
	Stopped.SetEvent();
	return -1;
}
//MessageLog(L" "+SDlg->ServerName,pDlg->hWnd);
MessageLog(L" "+SDlg->ServerName+L"...OK",pDlg->hWnd,NM_INFO | NM_DONE | NM_ONLINE);
pTrafInspAdmin.Attach((ITrafInspAdmin*)mqResults.pItf);
MessageLog(CString(L"  TI"),pDlg->hWnd,NM_INFO);
 _variant_t pwd = SDlg->APIPass.GetBuffer(0);
try
 {
	_variant_t result = pTrafInspAdmin->APILogon(pwd);
	} 
catch(...){
		AfxMessageBox(L" .   I  " + SDlg->ServerName);
		MessageLog(L" .   I  " + SDlg->ServerName,pDlg->hWnd,CRITICAL_ERROR | NM_OFFLINE);
		Stopped.SetEvent();
		return -1;
	}
MessageLog(CString(L"  TI...OK"),pDlg->hWnd,NM_INFO | NM_DONE |  NM_ONLINE);
//::SendMessage(pDlg->hWnd,WM_CONNECTEDOK,0,0);
if(pDlg->TICmd.command & TI_GETUSERS){
		MessageLog(CString(L"   TI"),pDlg->hWnd,NM_INFO);
		_variant_t us;
		try
		 {
		  us = pTrafInspAdmin->APIGetListXML(itUserAttrData ,NULL,NULL,0);
		}catch(...)
		{
		MessageLog(CString(L"."),pDlg->hWnd,CRITICAL_ERROR | NM_OFFLINE);
		Stopped.SetEvent();
		return -1;
		}

		//CFile f;
		//CFileException e;
		//
		//
		//if( !f.Open( L"tispd.xml", CFile::modeCreate | CFile::modeReadWrite | CFile::modeNoTruncate, &e ) )
		//   {
		//
		////   log.AddString(L"  \"" + SDlg.tispdlog + "\"     ");
		//     }
		//else{
		//CString str = message + " " + (*mess)+"\n";
			BSTR b = us.bstrVal;
		//f.SeekToEnd();
		//f.Write(b,wcslen(b)*sizeof(b));
		//f.Close();
		CString usr;
		////////////
		_bstr_t s(b);
		int i=0;

		int len = s.length();
		wchar_t *str = (wchar_t *)s;

		wchar_t *pstr = str;

		while(pstr){
		usr="";
		pstr = wcsstr(pstr,L"DisplayName=\"");
		if(pstr==NULL)
		break;
		pstr = (pstr+ wcslen(L"DisplayName=\""));

		while(*pstr!='\"')
		{
			if(pstr==NULL)
				break;
		usr=usr+*pstr;
		pstr++;
		}
		pDlg->Adduser(usr);
		MessageLog(CString(L" ."),pDlg->hWnd,NM_INFO);
		}
}
if(pDlg->TICmd.command & TI_GETGROUPS)
{
	variant_t GroupName_t;
	CString GroupName;
	CString str,msg;
	MessageLog(CString(L"   TI"),pDlg->hWnd,NM_INFO);
	for(int i=0; i<pDlg->maxuserscount;i++)
	{
		
		variant_t user = pDlg->Users[i].UserName_0.GetBuffer(0);
		try{
			GroupName_t = pTrafInspAdmin->APIGetAttr(APIObjectTypeUser, user, User_GroupName);
		MessageLog(str+L"...OK",pDlg->hWnd, NM_CHANGE_PARAM | NM_DONE);
		}catch(...){
			msg = L"      " + pDlg->Users[i].UserName_0;
			MessageLog(msg,pDlg->hWnd,CRITICAL_ERROR);
		}
		GroupName = GroupName_t.bstrVal;
		//
	
			pDlg->Users[i].groupid = pDlg->Groups.GetIdbyName(GroupName);
		//	if(pDlg->Users[i].groupid==-1)
			{
			 pDlg->Users[i].groupid=pDlg->Groups.AddGroup(GroupName);
	if (!GroupName.IsEmpty())
			{
			 variant_t maxin;

		try{
			maxin = pTrafInspAdmin->APIGetAttr(APIObjectTypeGroup,GroupName.GetBuffer(0)
				,   Group_InBandwidth  /*      -  , /*/);
				}catch(...){
			msg = L"     " + GroupName;
			MessageLog(msg,pDlg->hWnd,CRITICAL_ERROR);
		}
		long maxgrin = maxin.lVal;
		pDlg->Groups.SetInBand(pDlg->Users[i].groupid,maxgrin/(float)pDlg->SDlg.dmaxin);

			}


		}
	
	}
}
///////////
MessageLog(CString(L"  ."),pDlg->hWnd,NM_INFO | NM_OFFLINE);
::SendMessage(pDlg->hWnd,WM_USERSUPDATED,0,0);
Stopped.SetEvent();
return 1;
}



UINT ConectTI(LPVOID* lp)
{
HRESULT hr;
	CtispdDlg *pDlg = (CtispdDlg *)lp;
	CSettDlg *SDlg =&pDlg->SDlg;
CComPtr<ITrafInspAdmin> pTrafInspAdmin;	

	if(WaitForSingleObject(Stopped,0)==WAIT_TIMEOUT)
	{
		Break.SetEvent();
		MessageLog(CString("  ..."),pDlg->hWnd,NM_INFO);
		WaitForSingleObject(Stopped,INFINITE);
		MessageLog(CString(" ...."),pDlg->hWnd,NM_INFO | NM_OFFLINE);
	}
		Stopped.ResetEvent();
		Break.ResetEvent();
	int juststarted=1;
	double reszamer=0;
	int GlobalCountHiAct=0;
	int GlobalCountICQ=0;
	int GlobalCountOnLine=0;
	int GlobalCountSleep=0;

	tagVARIANT HUGEP *UserStat;
	_variant_t State;
COSERVERINFO csServerInfo = {0L, SDlg->ServerName.GetBuffer(0), 0, 0};
MULTI_QI mqResults = {&IID_ITrafInspAdmin, NULL, 0};
hr = CoInitializeEx(NULL, COINIT_MULTITHREADED);
_variant_t cmd;
MessageLog(L" "+SDlg->ServerName,pDlg->hWnd,NM_INFO);
hr = CoCreateInstanceEx(CLSID_TrafInspAdmin, NULL, CLSCTX_ALL, &csServerInfo, 1, &mqResults);
if (hr!=S_OK)
{
	MessageLog(L"   " + SDlg->ServerName,pDlg->hWnd,CRITICAL_ERROR | NM_OFFLINE);
	AfxMessageBox(L"   " + SDlg->ServerName);
	Stopped.SetEvent();
	return -1;
}
MessageLog(L" "+SDlg->ServerName+L"...OK",pDlg->hWnd,NM_INFO | NM_DONE | NM_OFFLINE);
pTrafInspAdmin.Attach((ITrafInspAdmin*)mqResults.pItf);
MessageLog(CString(L"  TI"),pDlg->hWnd,NM_INFO);
 _variant_t pwd = SDlg->APIPass.GetBuffer(0);
try
 {
	_variant_t result = pTrafInspAdmin->APILogon(pwd);
	} 
catch(...){
		AfxMessageBox(L" .   I  " + SDlg->ServerName);
		MessageLog(L" .   I  " + SDlg->ServerName,pDlg->hWnd,CRITICAL_ERROR | NM_OFFLINE);
		Stopped.SetEvent();
		return -1;
	}
MessageLog(CString(L"  TI...OK"),pDlg->hWnd,NM_INFO | NM_DONE | NM_ONLINE);

double maxcurin=0.0;
double maxcurout=0.0;
double SumTraffIn=0.0;
double SumTraffOut=0.0;
//List = 17, AttrLevel = 2.

int downloaderindex = -1;

/**************************************************************************************/
CString UserID;
_variant_t user;
_variant_t param;
bool ZamerMode=FALSE;// .  
int iter=0;

CString str;

CString msg;
int prevmode = -1;
int firstStart=1;
while(pTrafInspAdmin!=NULL)
{
SumTraffIn=0.0;
SumTraffOut=0.0;

	pDlg->Groups.ResetAllActiveData();

long downIN = pDlg->SDlg.dmaxin; //.    
long downOUT = pDlg->SDlg.dmaxout;
_variant_t test;
double CurSpeed=0L;
reszamer=downIN;

if(prevmode!=pDlg->SDlg.mode)
{
 switch(pDlg->SDlg.mode)
{
case 0:MessageLog(CString(L"  ( )"),pDlg->hWnd,NM_MODE);
	break;
case 1:
	MessageLog(L"      " + pDlg->SDlg.Downloader,pDlg->hWnd,NM_MODE);
	break;
case 2:MessageLog(CString(L"   "),pDlg->hWnd,NM_PROMPT);
	break;
case 3:MessageLog(CString(L"       !"),pDlg->hWnd,NM_MODE);
	if((pDlg->SDlg.timezamer>0) && (pDlg->SDlg.tzamer) && (pDlg->SDlg.useautochanal))
	{
		MessageLog(CString(L"     !!"),pDlg->hWnd,NM_MODE);
		ZamerMode=TRUE;
	}
		

	break;
default:
	MessageLog(CString(L" !!!"),pDlg->hWnd,NM_INFO);
}
 prevmode=pDlg->SDlg.mode;
}
 int maxuserscount=pDlg->maxuserscount;
 
 	GlobalCountHiAct=0;
	GlobalCountICQ=0;
	GlobalCountOnLine=0;
	GlobalCountSleep=0;
for(int i=0; i<pDlg->maxuserscount;i++)
{
	maxuserscount=pDlg->maxuserscount;	
	maxcurin=0;
	maxcurout=0;

	 UserID = pDlg->Users[i].UserName_0;
	user = UserID.GetBuffer(0);
if(UserID==L"")
	continue;
//if(WaitForSingleObject(ChangeSpeedlim,0)==WAIT_OBJECT_0)
   if(pDlg->Users[i].NewRXSpeed!=-1)
	{
		//    
		str.Format(L"   %s  %d/%d  %d/%d /.",UserID.GetBuffer(0),
			pDlg->Users[i].RXSPDContract,pDlg->Users[i].TXSPDContract,
			pDlg->Users[i].NewRXSpeed,pDlg->Users[i].NewTXSpeed);
		MessageLog(str,pDlg->hWnd, NM_CHANGE_PARAM);

			
		try{
		if(pDlg->Users[i].NewTXSpeed!=-1)
			hr = pTrafInspAdmin->APISetAttr(APIObjectTypeUser, user, User_OutBandwidth, pDlg->Users[i].NewTXSpeed,TRUE);
		if(pDlg->Users[i].NewRXSpeed!=-1)
			hr = pTrafInspAdmin->APISetAttr(APIObjectTypeUser, user, User_InBandwidth, pDlg->Users[i].NewRXSpeed  ,TRUE);
		MessageLog(str+L"...OK",pDlg->hWnd, NM_CHANGE_PARAM | NM_DONE);
		}catch(...){
			msg = L"   !      /  " + UserID + L"    "+SDlg->ServerName+L"    " +  UserID + L"   - ->/ -       > 0,   \" \", !  ";
		AfxMessageBox(msg);
		MessageLog(msg,pDlg->hWnd,CRITICAL_ERROR);
		pDlg->SDlg.mode=0;
		}

		pDlg->Users[i].NewRXSpeed=-1;
		pDlg->Users[i].NewTXSpeed=-1;
		
		ChangeSpeedlim.ResetEvent();
   }
   
	try
	{
		State = pTrafInspAdmin->APIGetUserState(user);
	}
	catch(...)
	{
		if(pTrafInspAdmin)
			pTrafInspAdmin.Release();
			AfxMessageBox(L"     \"" + UserID+"\"   ");
			MessageLog(L"     \"" + UserID+L"\"",pDlg->hWnd,CRITICAL_ERROR | NM_OFFLINE);
			Stopped.SetEvent();
			return -1;
	}
if(firstStart)
{
	try{
hr = pTrafInspAdmin->APISetAttr(APIObjectTypeUser, user,30,  FALSE, TRUE);
	}catch(...){

		//Srv.APISetAttr 3, UserID, 30, False, True - 
		MessageLog(L"     \"" + UserID+L"\"",pDlg->hWnd, NM_WARNING);		
	}

}
	hr = SafeArrayAccessData(State.parray, (void HUGEP**)&UserStat);
	pDlg->Users[i].UserName_0 = UserStat[0].bstrVal;
	CString ip;
	 ip = UserStat[24].bstrVal;
	 if(ip!=L"0.0.0.0")
		 if(pDlg->Users[i].IP_24!=L"0.0.0.0")
		 {
			 if(pDlg->Users[i].IP_24!=L"")
				 if(ip!=pDlg->Users[i].IP_24)
				 {
					 MessageLog(pDlg->Users[i].UserName_0+
						 L" IP   " + pDlg->Users[i].IP_24 + 
						 L" " + ip
						 ,pDlg->hWnd,NM_WARNING);

				 }
			pDlg->Users[i].IP_24 = ip;		 
		 }

	 
	pDlg->Users[i].Balance_19 = UserStat[19].dblVal;
	if(pDlg->Users[i].Active_10!=UserStat[10].lVal)
	{
		if(pDlg->Users[i].Active_10)
			MessageLog(pDlg->Users[i].UserName_0+L" - ",pDlg->hWnd,NM_INFO);
		else
			MessageLog(pDlg->Users[i].UserName_0+L" - ",pDlg->hWnd,NM_INFO);
		pDlg->Users[i].Active_10 = UserStat[10].lVal;
	}
	long double r20,t21;
	if(UserStat[20].vt == VT_R8)
		r20 = UserStat[20].dblVal;
	else
		r20 = UserStat[20].lVal;

	if(UserStat[21].vt == VT_R8)
		t21 = UserStat[21].dblVal;
	else
		t21 = UserStat[21].lVal;

		
	if(pDlg->Users[i].RX_20 > 0.0)
	{  //      ()
		maxcurin = ((r20 - pDlg->Users[i].RX_20)/((double)SDlg->timemsec/1000.0*1024.0))*8.0; 
	}
	if(pDlg->Users[i].TX_21 > 0.0)
	{  //      
		maxcurout = ((double)(t21 - pDlg->Users[i].TX_21)/((double)SDlg->timemsec/1000.0*1024.0))*8.0; 
	}

	pDlg->Users[i].RX_20 = r20;
	pDlg->Users[i].TX_21 = t21;
	pDlg->Users[i].RXSPD_33 = (double)(UserStat[33].lVal*8.0)/1024.0;
	pDlg->Users[i].TXSPD_34 = (double)(UserStat[34].lVal*8.0)/1024.0;
	//CurSpeed =CurSpeed + pDlg->Users[i].RXSPD_33;
	CurSpeed =CurSpeed + maxcurin;
	SafeArrayUnaccessData(State.parray);
	_variant_t lastact;
	try{
	//	variant_t u[2];
	//	u[0]=(_variant_t)"User_InBandwidth";
	//	u[1]=(_variant_t)"User_InBandwidth";
	pDlg->Users[i].TXSPDContract = pTrafInspAdmin->APIGetAttr(APIObjectTypeUser, user, (_variant_t)"User_OutBandwidth");
	pDlg->Users[i].RXSPDContract = pTrafInspAdmin->APIGetAttr(APIObjectTypeUser, user, (_variant_t)"User_InBandwidth");
	//variant_t l=pTrafInspAdmin->APIGetAttr(APIObjectTypeUser, user, &u);;
	

	//User_LastAnyTraffActive  = 78; //     ,    
	lastact = pTrafInspAdmin->APIGetAttr(APIObjectTypeUser, user,User_LastAnyTraffActive);
	}catch(...){
			MessageLog(CString("    "),pDlg->hWnd,NM_WARNING);
			
		}

	if(juststarted)
	{
	pDlg->Users[i].TXSPDContractFirst = pDlg->Users[i].TXSPDContract;
	pDlg->Users[i].RXSPDContractFirst = pDlg->Users[i].RXSPDContract;
	}

	SYSTEMTIME newlastact;
	VariantTimeToSystemTime(lastact, &newlastact);
	//
	
	pDlg->Users[i].AvgRX=maxcurin;
	pDlg->Users[i].AvgTX=maxcurout;
SumTraffIn+=(double)(pDlg->Users[i].RX_20);
SumTraffOut+=(double)(pDlg->Users[i].TX_21);

/////
	
	if(pDlg->Users[i].Active_10)
	{
		GlobalCountOnLine++;
		if((pDlg->SDlg.IsSleepuser(newlastact))&&(pDlg->SDlg.useusersleep))
		{
			pDlg->Groups.AddSleeper(pDlg->Users[i].groupid);
			if(pDlg->Users[i].status!=U_SLEEP)
			{
				str.Format(L"%s  ( : %d.%02d.%02d/%d:%02d:%02d",pDlg->Users[i].UserName_0,
				newlastact.wDay,newlastact.wMonth,newlastact.wYear,
				newlastact.wHour,newlastact.wMinute,newlastact.wSecond);
				MessageLog(str,pDlg->hWnd,INFO);

			}
			pDlg->Users[i].status=U_SLEEP;
		GlobalCountSleep++;
	
		}
		else
		{
		if(pDlg->Users[i].status==U_SLEEP)
		{
			str.Format(L"%s !",pDlg->Users[i].UserName_0);
			MessageLog(str,pDlg->hWnd,INFO);
		}
		if(pDlg->IsICQUser(i))
		{
			pDlg->Groups.AddICQAct(pDlg->Users[i].groupid);
			pDlg->Users[i].status=U_ICQ;
			GlobalCountICQ++;
		}
		else
		{
			pDlg->Users[i].status=U_ACT;
			GlobalCountHiAct++;
			pDlg->Groups.AddActive(pDlg->Users[i].groupid,pDlg->Users[i].ktraff);
		}
		

		}
	}
	else
		pDlg->Users[i].status=U_OFFLINE;
	pDlg->Users[i].lastacttime=newlastact;
	if(pDlg->SDlg.mode==1)
		if(pDlg->Users[i].UserName_0!=pDlg->SDlg.Downloader)
		{
			if(!pDlg->CanIncreaseTraffic(i))
			//if(pDlg->Users[i].Active_10!=0)
			{
			downIN = downIN - pDlg->Users[i].RXSPDContract;
			downOUT = downOUT - pDlg->Users[i].TXSPDContract;
			}
		}
		else
		if(pDlg->Users[i].Active_10!=0)
			downloaderindex = i;



	if(pDlg->Users[i].RXSPD_33 > maxcurin)
		maxcurin = pDlg->Users[i].RXSPD_33;
	if(pDlg->Users[i].TXSPD_34 > maxcurout)
		maxcurout = pDlg->Users[i].TXSPD_34;

	pDlg->Users[i].PersentRXSPD = (maxcurin/pDlg->Users[i].RXSPDContract)*100.0;
	pDlg->Users[i].PersentTXSPD = (maxcurout/pDlg->Users[i].TXSPDContract)*100.0;
}



juststarted=0;			


double sumktraff=0.0; //    
int kanalfordivMAX=pDlg->SDlg.dmaxin;
int CountAct=0;
int CountICQ=0;
int CountSleepers=0;
CString str;
pDlg->Groups.GetCountAct(CountAct,CountSleepers, CountICQ);
		if((downIN<0)||(downOUT<0))
		{// !
			downIN=1;
			downOUT=1;
			MessageLog(CString(L" !"),pDlg->hWnd,NM_WARNING);
		}

	if (pDlg->SDlg.mode==1)
	{
		if(downloaderindex >=0)
		if(pDlg->Users[downloaderindex].Active_10!=0)//    
			if((pDlg->Users[downloaderindex].RXSPDContract!=downIN)||(pDlg->Users[downloaderindex].TXSPDContract!=downOUT))
			{
				CString str;
				str.Format(L"   %s  %d/%d  %d/%d /.",pDlg->SDlg.Downloader.GetBuffer(0),
				pDlg->Users[downloaderindex].RXSPDContract,pDlg->Users[downloaderindex].TXSPDContract,downIN,downOUT);
				MessageLog(str,pDlg->hWnd, NM_CHANGE_PARAM);
				user = pDlg->SDlg.Downloader.GetBuffer(0);
				cmd = L"User_InBandwidth";
				param = downIN;
				 try{
					if(pDlg->Users[downloaderindex].RXSPDContract!=downIN)
						pTrafInspAdmin->APISetAttr(APIObjectTypeUser, user, cmd, param ,TRUE);
					if(pDlg->Users[downloaderindex].TXSPDContract!=downOUT)
					{
							cmd = L"User_OutBandwidth";
							param = downOUT;
						pTrafInspAdmin->APISetAttr(APIObjectTypeUser, user, cmd, param ,TRUE);
					}
					MessageLog(str+L"...OK",pDlg->hWnd, NM_CHANGE_PARAM | NM_DONE);
				}catch(...){
						msg = L"   !      /  " + pDlg->SDlg.Downloader + L"    "+SDlg->ServerName+L"    " +  pDlg->SDlg.Downloader + L"   - ->/ -       > 0,   \" \", !  ";
						AfxMessageBox(msg);
						MessageLog(msg,pDlg->hWnd,CRITICAL_ERROR);
						pDlg->SDlg.mode=0;
					}
			}
			

		}

	else
	if (pDlg->SDlg.mode==3) // !
	{
		if(pDlg->SptPg.trafflimmode==1)
		{
		
				double sk = pDlg->SptPg.startkoeff;
				double ek = pDlg->SptPg.endktraff;
				double st = pDlg->SptPg.safetraff*1024*1024;
				double mt = pDlg->SptPg.maxtraff*1024*1024;
				for(int i=0;i<maxuserscount;i++)
				{
					double x = pDlg->Users[i].RX_20;
					if(x<st)
					{
						pDlg->Users[i].ktraff = sk;
						continue;
					}

					
					if(x>=mt)
					{
						pDlg->Users[i].ktraff = pDlg->SptPg.endktraff;
						if(pDlg->SptPg.dnomaxkbits>0)
						{
							pDlg->Users[i].LimitMaxInkbit  = pDlg->SptPg.dnomaxkbits;
							pDlg->Users[i].LimitMaxOutkbit  = pDlg->SptPg.dnomaxkbits;
						}
						continue;
					}
					
					pDlg->Users[i].ktraff =  sk + (ek-sk)*(x-st)/(mt-st);
				}
		
		}
		int kanalfordiv = pDlg->SDlg.dmaxin - pDlg->SDlg.sleeptraff * CountICQ;
		//	-------------------------------------- ZAMER
		if(ZamerMode)
		{
				reszamer = CurSpeed+pDlg->SDlg.CorrectRX*CountAct;
				str.Format(L" : %.0f /.",reszamer);
								MessageLog(str,pDlg->hWnd, NM_INFO);
				if(reszamer > pDlg->SDlg.dmaxin)
					reszamer = pDlg->SDlg.dmaxin;
				else
				if(reszamer < pDlg->SDlg.minRXchanal)
					reszamer = pDlg->SDlg.minRXchanal;
				str.Format(L" : %.0f /.",reszamer);
								MessageLog(str,pDlg->hWnd, NM_INFO);
				kanalfordiv=reszamer - pDlg->SDlg.sleeptraff * CountICQ;
			}
		//------------------
			if(CountAct!=0)
			{
				int idgr;
				int indexgr;
				kanalfordivMAX=kanalfordiv;

				pDlg->Groups.GroupList[0].Group_InBandwidth=1.0;
				
				for(int j=1;j<pDlg->Groups.countgroups;j++)
				{
					if(pDlg->Groups.GroupList[j].countact>0)
/****/					{
					//	int realmaxkbitforgr = pDlg->GetMaxGrChanal(pDlg->Groups.GroupList[j].id,kanalfordivMAX);
						pDlg->Groups.GroupList[0].Group_InBandwidth-=pDlg->Groups.GroupList[j].Group_InBandwidth;
					}

				}
				pDlg->Checkuindex();
				int usefreech = pDlg->SDlg.usefreechanal;
				if(usefreech)
				pDlg->SortUsers();
				USindex* puser = pDlg->uindex;
				double maxout = pDlg->SDlg.dmaxout;
				for(int i=0;i<pDlg->uindexsize;i++)
				{
					
					if(puser[i].pUser->Active_10==0)
						continue;
					if(puser[i].pUser->status==U_SLEEP)
						continue;
					idgr = puser[i].pUser->groupid;
					indexgr = pDlg->Groups.GetIndexbyId(idgr);
					//int nmaxin = (int)((double)kanalfordiv*(puser[i].pUser->ktraff/pDlg->Groups.GroupList[indexgr].ktraff);
					float ktraffIn = pDlg->Groups.GroupList[indexgr].ktraff;
					float ktraffOut = pDlg->Groups.GroupList[indexgr].ktraffOut;
					int nmaxin = (int)((double)pDlg->Groups.GetInBand(idgr)*kanalfordivMAX*(puser[i].pUser->ktraff/ktraffIn));

					int nmaxout = (int)((double)pDlg->Groups.GetInBand(idgr)*(maxout)*(puser[i].pUser->ktraff/ktraffOut));;
						//(int)((double)(maxout*countact)*(puser[i].pUser->ktraff/pDlg->Groups.GroupList[indexgr].ktraff);
					//int nmaxout = (int)((double)(maxout*countact)*(puser[i].pUser->ktraff/pDlg->Groups.GroupList[indexgr].ktraff);
					
						if(pDlg->SDlg.usemaxspeedlimit)
							{
								if(puser[i].pUser->LimitMaxInkbit>0)
								if( nmaxin > puser[i].pUser->LimitMaxInkbit)
								{
									if(usefreech)
									{
									kanalfordivMAX-=puser[i].pUser->LimitMaxInkbit;
									pDlg->Groups.GroupList[indexgr].ktraff =  pDlg->Groups.GroupList[indexgr].ktraff - puser[i].pUser->ktraff;
									}

									nmaxin = puser[i].pUser->LimitMaxInkbit;
								}
								
								if(puser[i].pUser->LimitMaxOutkbit>0)
								if( nmaxout > puser[i].pUser->LimitMaxOutkbit)
								{
									nmaxout = puser[i].pUser->LimitMaxOutkbit;
									if(usefreech)
									{
									maxout-=puser[i].pUser->LimitMaxOutkbit;
									pDlg->Groups.GroupList[indexgr].ktraffOut =  pDlg->Groups.GroupList[indexgr].ktraffOut - puser[i].pUser->ktraff;
									}
								}


							}

							if(nmaxin>kanalfordivMAX)
								nmaxin = kanalfordivMAX;

							if(nmaxout>pDlg->SDlg.dmaxout)
								nmaxout=pDlg->SDlg.dmaxout;

							if(nmaxin<=0)
								nmaxin = 1;

							if(nmaxout<=0)
								nmaxout=1;

					if((puser[i].pUser->RXSPDContract!=nmaxin)
					||(puser[i].pUser->TXSPDContract!=nmaxout))
					{
							if(pDlg->IsICQUser(i))
								if((puser[i].pUser->RXSPDContract > nmaxin) 
									|| (puser[i].pUser->RXSPDContract > pDlg->SDlg.sleeptraff))
									continue;
						
							//CString str;
							//str.Format(L"   %d     ",divby);
							//MessageLog(str,pDlg->hWnd,INFO);
						/*
						str.Format(L"   %s  %d/%d  %d/%d /.",puser[i].pUser->UserName_0.GetBuffer(0),

							puser[i].pUser->RXSPDContract,puser[i].pUser->TXSPDContract,maxin,maxout);
							*/
							str.Format(L"   %s  %d/%d /.",puser[i].pUser->UserName_0.GetBuffer(0),nmaxin,nmaxout);
							MessageLog(str,pDlg->hWnd, NM_CHANGE_PARAM);
							user = puser[i].pUser->UserName_0.GetBuffer(0);
							cmd = L"User_InBandwidth";
						
						//	pTrafInspAdmin->APISetAttr(APIObjectTypeUser, user, cmd, param,TRUE);
							try{
								param = nmaxin;
								if(puser[i].pUser->RXSPDContract!=nmaxin)
								{
									pTrafInspAdmin->APISetAttr(APIObjectTypeUser, user, cmd, param ,TRUE);
									puser[i].pUser->RXSPDContract = nmaxin;
								}

								
								if(puser[i].pUser->TXSPDContract!=nmaxout)
								{
										cmd = L"User_OutBandwidth";
										param = nmaxout;
									pTrafInspAdmin->APISetAttr(APIObjectTypeUser, user, cmd, param ,TRUE);
									puser[i].pUser->TXSPDContract=nmaxout;
								}
								MessageLog(str+L"...OK",pDlg->hWnd, NM_CHANGE_PARAM | NM_DONE);
							}catch(...){
								msg = L"   !      /  " + pDlg->SDlg.Downloader + L"    "+SDlg->ServerName+L"    " +  pDlg->SDlg.Downloader + L"   - ->/ -       > 0,   \" \", !  ";
								AfxMessageBox(msg);
								MessageLog(msg,pDlg->hWnd,CRITICAL_ERROR);
								pDlg->SDlg.mode=0;
								}
	//puser[i].pUser->TXSPDContract = pTrafInspAdmin->APIGetAttr(APIObjectTypeUser, user, User_OutBandwidth);
	//pDlg->Users[i].RXSPDContract = pTrafInspAdmin->APIGetAttr(APIObjectTypeUser, user, User_InBandwidth);
					}
				}
			}
		}

//////////////////////************************/////////////////////
/*
				CString str;
				str.Format(L")RX:%.0f :%d :%d :%d :%d. (=%g)",(double)reszamer/pDlg->kbytes,maxuserscount, CountReallyAct, SleepersCount, ICQUsersCount, sumktraff);
				
					 MessageLog(CString(L"(")+pDlg->speedval+str,pDlg->hWnd, NM_PROMPT);
						prevcountact=countact;
			}
		}
		if (pDlg->SDlg.mode!=3) 
		{
					
				CString str;
						str.Format(L" : %d ", countact);
						MessageLog(str,pDlg->hWnd, NM_PROMPT);
			
		}*/
	/*	str.Format(L":%.2f+%.2f=%2.f. :%.1f/%.1f%s, :%d :%d :%d :%d :%d :%d",SumTraffIn/1024.00/1024.00,SumTraffOut/1024.00/1024.00,SumTraffIn/1024.00/1024.00+SumTraffOut/1024.00/1024.00,
			(kanalfordivMAX+pDlg->SDlg.sleeptraff * CountICQ)/pDlg->kbytes,pDlg->SDlg.dmaxout/pDlg->kbytes,pDlg->speedval.GetBuffer(0),
		   pDlg->Groups.countgroups-1,maxuserscount, GlobalCountOnLine, GlobalCountHiAct, GlobalCountSleep, GlobalCountICQ);


	*/		str.Format(L":%d :%d :%d :%d :%d",maxuserscount, GlobalCountOnLine, GlobalCountHiAct, GlobalCountICQ, GlobalCountSleep);
	
						MessageLog(str,pDlg->hWnd, NM_PROMPT);

						 pDlg->Srv.str[0].Format(L":%d",pDlg->Groups.countgroups-1);
						 pDlg->Srv.str[1].Format(L":%d",maxuserscount);
						 pDlg->Srv.str[2].Format(L":%d",GlobalCountOnLine);
						 pDlg->Srv.str[3].Format(L":%d",GlobalCountHiAct);
						 pDlg->Srv.str[4].Format(L".:%d",GlobalCountICQ);
						 pDlg->Srv.str[5].Format(L":%d",GlobalCountSleep);
						 						 

						 pDlg->Srv.RX_20 = SumTraffIn;
						 pDlg->Srv.TX_21 = SumTraffOut;
						 pDlg->Srv.RXSPDContract = (kanalfordivMAX+pDlg->SDlg.sleeptraff * CountICQ);
						 pDlg->Srv.TXSPDContract = pDlg->SDlg.dmaxout;



		firstStart=0;
		::SendMessage(pDlg->hWnd,WM_CONNECTEDOK,0,0);
		//Sleep(pDlg->SDlg.timemsec);
		if(WaitForSingleObject(ChangeTarif,0))
		{
			ChangeTarif.ResetEvent();

		}


		if(WaitForSingleObject(Break,SDlg->timemsec)==WAIT_OBJECT_0)
		{
		
			//if(WaitForSingleObject(QuitTIspd,0)==WAIT_OBJECT_0)
			
				switch(pDlg->SDlg.beforequit)
				{
				case 0:  //   
					msg = L"  .   ";
					break;
				case 1: msg = L"  .     ,  ";//  0/0
						for(int i=0;i<maxuserscount;i++)
						{
							if(pDlg->Users[i].LimitMaxOutkbit<=0)
								pDlg->Users[i].TXSPDContract = 0;
							else
								pDlg->Users[i].TXSPDContract = pDlg->Users[i].LimitMaxOutkbit;

							if(pDlg->Users[i].LimitMaxInkbit<=0)
								pDlg->Users[i].RXSPDContract = 0;
							else
								pDlg->Users[i].RXSPDContract = pDlg->Users[i].LimitMaxInkbit;

						}
						
					break;
				case 2:	msg = L"  .     ";// 
					for(int i=0;i<maxuserscount;i++)
					{
						pDlg->Users[i].TXSPDContract = pDlg->Users[i].TXSPDContractFirst;
						pDlg->Users[i].RXSPDContract = pDlg->Users[i].RXSPDContractFirst;
					}
					break;
				}
					MessageLog(msg,pDlg->hWnd,NM_INFO);
				if((pDlg->SDlg.beforequit==1)||(pDlg->SDlg.beforequit==2))
					for(int i=0;i<maxuserscount;i++)
					{
							msg.Format(L" %d/%d   ",pDlg->Users[i].RXSPDContract,pDlg->Users[i].TXSPDContract);
							MessageLog(CString( msg + pDlg->Users[i].UserName_0),pDlg->hWnd, NM_CHANGE_PARAM | NM_DONE);
							try{
	
								user = pDlg->Users[i].UserName_0.GetBuffer(0);
								cmd = L"User_InBandwidth";
								param = pDlg->Users[i].RXSPDContract;
								pTrafInspAdmin->APISetAttr(APIObjectTypeUser, user, cmd, param ,TRUE);
													
								cmd = L"User_OutBandwidth";
								param = pDlg->Users[i].TXSPDContract;
								pTrafInspAdmin->APISetAttr(APIObjectTypeUser, user, cmd, param ,TRUE);
								}
								catch(...){
									msg = L"     /  " +   pDlg->Users[i].UserName_0;
								MessageLog(msg,pDlg->hWnd,CRITICAL_ERROR);
								//pDlg->SDlg.mode=0;
								}

					}

			if(pTrafInspAdmin)
				pTrafInspAdmin.Release();
				MessageLog(CString(L"  ....  ."),pDlg->hWnd, NM_WARNING | NM_OFFLINE);
				Stopped.SetEvent();
				return 0;
		}
		

	}
Stopped.SetEvent();
MessageLog(CString(L"  ....  ."),pDlg->hWnd, NM_WARNING | NM_OFFLINE); 
return 0;

}



// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedOk();
public:
	CString forum;
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
, forum(_T("http://forum.ru-board.com/topic.cgi?forum=5&bm=1&topic=22564#1"))
{
	
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, forum);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	ON_BN_CLICKED(IDOK, &CAboutDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CtispdDlg dialog




CtispdDlg::CtispdDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CtispdDlg::IDD, pParent)
	, SelectedItem(0)
	, pSliders(NULL)
	, maxuserscount(0)
	, isonline(NM_OFFLINE)
	, sumktraff(0)
{
	hide=0;
	//pTrafInspAdmin=NULL;
	vstr=1;
	firststart=1;
	//Users=NULL;
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	hWnd=NULL;
	ShowNoAct=1;
	SortByCol=0;
	for(int i=0;i<MAXCOLUMNS;i++)
		SortWay[i]=-1;
kbytes = 1.0;
speedval="/";
GrDlg.pTIDlg = (CDialog*)this;
uindex = NULL;
uindexsize=0;

}

void CtispdDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, List);
	DDX_Control(pDX, IDC_COMBOLOG, log);
	DDX_Control(pDX, IDC_EDIT_PROMPT, EditPrompt);
}

BEGIN_MESSAGE_MAP(CtispdDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CtispdDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDM_ABOUTBOX, &CtispdDlg::OnAbout)
	ON_BN_CLICKED(IDOK, &CtispdDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_BUTTON2, &CtispdDlg::OnBnClickedButton2)
	ON_NOTIFY(HDN_TRACK, 0, &CtispdDlg::OnHdnTrackList1)
	ON_NOTIFY(HDN_ITEMCHANGING, 0, &CtispdDlg::OnHdnItemchangingList1)
	ON_NOTIFY(HDN_ITEMCHANGED, 0, &CtispdDlg::OnHdnItemchangedList1)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_LIST1, &CtispdDlg::OnNMReleasedcaptureList1)
	//ON_WM_TIMER()
	ON_MESSAGE(WM_CONNECTEDOK,&CtispdDlg::ReciveData)
	ON_MESSAGE(WM_TRAYICON,OnTrayIconEvent)

	ON_MESSAGE(WM_USERSUPDATED,&CtispdDlg::UsersUpdated)
	ON_MESSAGE(WM_MESSLOG,&CtispdDlg::AddLog)
	ON_NOTIFY(LVN_ENDSCROLL, IDC_LIST1, &CtispdDlg::OnLvnEndScrollList1)
	ON_WM_SIZING()
	ON_NOTIFY(NM_DBLCLK, IDC_LIST1, &CtispdDlg::OnNMDblclkList1)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST1, &CtispdDlg::OnLvnItemchangedList1)
	ON_BN_CLICKED(IDC_BUTTON_SHOWLOG, &CtispdDlg::OnBnClickedButtonShowlog)
	ON_NOTIFY(HDN_ITEMCLICK, 0, &CtispdDlg::OnHdnItemclickList1)
	ON_BN_CLICKED(IDC_BUTTON_ADDUSERSFROMTI, &CtispdDlg::OnBnClickedButtonAddusersfromti)
	ON_BN_CLICKED(IDC_BUTTON_CONNECT, &CtispdDlg::OnBnClickedButtonConnect)
	ON_BN_CLICKED(ID_SHOWWINDOW,ShowWindowDlg)
	ON_BN_CLICKED(ID_CHANGESPEED,ChangeSpeedDlg)
	ON_BN_CLICKED(ID_DELFROMLIST, DeleteUser)
	ON_BN_CLICKED(ID_ADDUSERTOLIST,AddUserToList)
	ON_BN_CLICKED(ID_HIDEOFFLINEUSERS,HideShowOffline)
	ON_BN_CLICKED(ID_MODERD,ChangeModeRD)
	ON_BN_CLICKED(ID_MODEDIV,ChangeModeDiv)
	ON_BN_CLICKED(ID_SAVE,SaveSettings)
	ON_BN_CLICKED(ID_LOAD,LoadSettings)
	ON_BN_CLICKED(ID_QUIT,Quit)
	ON_NOTIFY(NM_RCLICK, IDC_LIST1, &CtispdDlg::OnNMRclickList1)

	ON_WM_RBUTTONDOWN()
	ON_NOTIFY(LVN_KEYDOWN, IDC_LIST1, &CtispdDlg::OnLvnKeydownList1)
	ON_BN_CLICKED(IDC_BUTTON_LOGOFF, &CtispdDlg::OnBnClickedButtonLogoff)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDc_BUTTON_GETGROUPSFROMTI, &CtispdDlg::OnBnClickedButtonGetgroupsfromti)
	ON_BN_CLICKED(IDC_BUTTON_GROUPS, &CtispdDlg::OnBnClickedButtonGroups)
	ON_WM_SHOWWINDOW()
	ON_WM_ACTIVATE()
END_MESSAGE_MAP()


// CtispdDlg message handlers

BOOL CtispdDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
		//List.SetExtendedStyle(LVS_EX_GRIDLINES | LVS_EX_FLATSB | LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES );
	//_wsetlocale(LC_ALL, L"" );
	//vstr = 16;
 //   Stopped.SetEvent();
	//CRowStyle styles[4];
	//styles[STANDARD].txtclr=RGB(200,15,200);//GetSysColor( COLOR_WINDOWTEXT );
	//styles[STANDARD].bkclr=RGB(245,255,245);//GetSysColor( COLOR_WINDOW );

	//styles[USEROFFLINE].txtclr=RGB(100,100,100);
	//styles[USEROFFLINE].bkclr=RGB(230,230,230);//=GetSysColor( COLOR_WINDOW );

	//styles[USERSLEEP].txtclr=RGB(50,50,200);
	//styles[USERSLEEP].bkclr=RGB(240,240,245);//GetSysColor( COLOR_WINDOW );

	//styles[ICQUSER].txtclr=RGB(50,150,50);
	//styles[ICQUSER].bkclr=RGB(240,250,240);//GetSysColor( COLOR_WINDOW );

	//List.InitStyles(styles,4);

	////{COMBOERROR,WARNING,CHANGE_PARAM,INFO};
	//CRowStyle combostyles[4];

	//combostyles[COMBOERROR].txtclr=RGB(255,255,255);
	//combostyles[COMBOERROR].bkclr=RGB(150,0,0);
	//combostyles[WARNING].txtclr=RGB(255,255,255);
	//combostyles[WARNING].bkclr=RGB(200,0,150);
	//combostyles[CHANGE_PARAM].txtclr=RGB(255,255,255);
	//combostyles[CHANGE_PARAM].bkclr=RGB(0,150,150);
	//combostyles[INFO].txtclr=RGB(200,255,200);
	//combostyles[INFO].bkclr=RGB(0,0,50);
	//log.InitStyles(combostyles,4);

//log.InsertString( 0, L"Red" );
//log.SetItemData( 0, 0x000000ff );
	Srv.UserName_0 = "Server_TI";
	Srv.IP_24 = SDlg.ServerName;
	Srv.RXSPDContract = SDlg.dmaxin;
	Srv.TXSPDContract = SDlg.dmaxout;
	InitList();
	UsersUpdated(0,0);
CreateIcon();

	if(SDlg.speedkbytes)
	{
		kbytes = 8.0;
		speedval="/";
	}
	else
	{
		kbytes = 1.0;
		speedval="/";
	}


//ResizeControls(&rect);
//InsertStr();


	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CtispdDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		OnAbout();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CtispdDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
	if(firststart)
	{
		hWnd=GetSafeHwnd();
		firststart=0;
	//	OnBnClickedButton2();
		//ResizeGrid();

		if(SDlg.startmin)
		{
		//	ResizeControls(&r);
			ResizeGrid();
			ShowWindow(SW_MINIMIZE);
			ShowWindow(SW_HIDE);
			hide =1;
		}
		if(SDlg.autologin)
		{
			OnBnClickedButtonConnect();
		}
	}
	


}


// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CtispdDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

HWND emule;
BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam )
{
	HWND	hTray3;//Tray
	hTray3 = ::FindWindowEx(hwnd,NULL,L"AfxWnd70su",NULL); 
	if(hTray3){}
		else return TRUE;
	::BringWindowToTop(hwnd);
	::SetForegroundWindow(hwnd);

	CString emuleinstr;
	CString emuleoutstr;
	wchar_t  eresIn[10],eresOUT[10];
	
	emuleinstr.Format(L"%d",newemuleIN);
	emuleoutstr.Format(L"%d",newemuleOUT);
	::SendDlgItemMessage(hwnd,IDC_DOWNTXT,WM_SETTEXT,0,(LPARAM)emuleinstr.GetBuffer(0));
	::SendDlgItemMessage(hwnd,IDC_UPTXT,WM_SETTEXT,0,(LPARAM)emuleoutstr.GetBuffer(0));
	{
	emuleIN=newemuleIN;
	emuleOUT=newemuleOUT;
	}
		
   return FALSE;
}


void CtispdDlg::OnBnClickedButton1()
{
	CString str;
	str.Format(L" c   %d/%d /.",newemuleIN,newemuleOUT);
	MessageLog(str,hWnd,NM_CHANGE_PARAM);
	//HWND hWndM=::FindWindow(L"TMainForm",NULL);
/*HWND hTray3;//Tray
hTray3 = ::FindWindow(L"Shell_TrayWnd",NULL);
if(hTray3 ==NULL){AfxMessageBox(L":(");return;}
hTray3 = ::FindWindowEx(hTray3,NULL,L"TrayNotifyWnd",NULL);
if(hTray3 ==NULL){AfxMessageBox(L":(");return;}
hTray3 = ::FindWindowEx(hTray3,NULL,L"SysPager",NULL); 
if(hTray3 ==NULL){AfxMessageBox(L":(");return;}
hTray3 = ::FindWindowEx(hTray3,NULL,L"ToolbarWindow32",NULL);
if(hTray3 ==NULL){AfxMessageBox(L":(");return;}
//::GetDlgItem(hTray3,
//hTray3 = ::FindWindowEx(hTray3,NULL,L"#32770 (Dialog)",NULL);
hTray3 = ::FindWindow(NULL,"");
while(hTray3!=NULL)
{

}*/
	LPARAM lParam = 0;
   EnumWindows( (WNDENUMPROC)EnumWindowsProc, lParam );

if((emuleIN!=newemuleIN)||(	emuleOUT!=newemuleOUT))
	MessageLog(CString(L"!       !"),hWnd,CRITICAL_ERROR);
else
	MessageLog(CString(L"  :)"),hWnd,NM_INFO);


//if(hTray3 ==NULL){AfxMessageBox(L":(");return;}



	/*
	HWND hWndM0=::FindWindow(L"Shell_TrayWnd",NULL);
if(hWndM0==NULL)
	{
		MessageLog(CString(L" Download Master  "),hWnd,CRITICAL_ERROR);

		return;

	}
::GetDlgItem(hWndM0,)
	HWND hWndM=::FindWindow(L"ToolbarWindow32",NULL);
	if(hWndM==NULL)
	{
		MessageLog(CString(L" Download Master  "),hWnd,CRITICAL_ERROR);

		return;
	}
	::SendMessage(hWndM,WM_ACTIVATE,0,0);
	::SendMessage(hWndM,WM_SETFOCUS,0,0);
	::SendMessage(hWndM,WM_USER+1280,0,0);
	
	//::SendMessage(hWndM,WM_CHAR,
	/*keybd_event(VK_SHIFT,0,KEYEVENTF_EXTENDEDKEY,0);
    keybd_event(VK_CTR,0,KEYEVENTF_EXTENDEDKEY,0);
    keybd_event(VK_SHIFT,0,KEYEVENTF_EXTENDEDKEY|KEYEVENTF_KEYUP,0);
	*/
	/*INPUT pInputs[3];
	pInputs[0].type=INPUT_KEYBOARD;
	pInputs[0].ki.dwFlags=KEYEVENTF_EXTENDEDKEY;
	pInputs[0].ki.wVk = VK_CONTROL | VK_SHIFT;
	pInputs[0].ki.time=0;
	pInputs[0].ki.dwExtraInfo=0;
	pInputs[0].ki.wScan='L';*/
/*
	pInputs[1].type=INPUT_KEYBOARD;
	pInputs[1].ki.dwFlags=KEYEVENTF_EXTENDEDKEY;
	pInputs[1].ki.wVk = VK_CONTROL;
	pInputs[1].ki.time=0;
	pInputs[1].ki.dwExtraInfo=0;
	pInputs[1].ki.wScan='L';

	pInputs[2].type=INPUT_KEYBOARD;
	pInputs[2].ki.dwFlags=KEYEVENTF_EXTENDEDKEY;
	pInputs[2].ki.wVk = VK_CONTROL | VK_SHIFT;
	pInputs[2].ki.time=0;
	pInputs[2].ki.dwExtraInfo=0;
	pInputs[2].ki.wScan='L';
*/



	/*UINT res = SendInput( 1,
    pInputs,
    sizeof(pInputs[0]));
*/

}

int CtispdDlg::InitList(void)
{
	CListCtrl* pmyListCtrl=&List;
	SelectedItem=-1;
	pmyListCtrl->DeleteAllItems();
	int nColumnCount = pmyListCtrl->GetHeaderCtrl()->GetItemCount();
	for (int c=nColumnCount-1;c >= 0;c--)
	{
		pmyListCtrl->DeleteColumn(c);
	}
//# define CURSPDRX 1 
//# define CURSPDTX 2
//# define SLIDER   3
	pmyListCtrl->InsertColumn(USERNAME,L"",LVCFMT_LEFT,70);
	pmyListCtrl->InsertColumn(USERIP,L"IP-",LVCFMT_LEFT,90);
	pmyListCtrl->InsertColumn(USER_BALANCE,L"",LVCFMT_LEFT,70);
	pmyListCtrl->InsertColumn(CONTRACTSPDRXTX,L". RX/TX",LVCFMT_LEFT,100);
	pmyListCtrl->InsertColumn(RXMB,L".",LVCFMT_LEFT,65);
	pmyListCtrl->InsertColumn(TXMB,L".",LVCFMT_LEFT,65);
	pmyListCtrl->InsertColumn(SLIDER,L"",LVCFMT_LEFT,65);
	pmyListCtrl->InsertColumn(AVGRXTX,L"..RX/TX",LVCFMT_LEFT,85);
	pmyListCtrl->InsertColumn(RXTXSPD,L"TI..RX/TX",LVCFMT_LEFT,85);
	pmyListCtrl->InsertColumn(LASTACTIVE,L".",LVCFMT_LEFT,118);
	pmyListCtrl->InsertColumn(KTRAFF,L"",LVCFMT_LEFT,65);
	pmyListCtrl->InsertColumn(GROUPNAME,L"",LVCFMT_LEFT,50);
	pmyListCtrl->InsertColumn(MAXSPEEDLIMIT,L"..",LVCFMT_LEFT,85);


	//pmyListCtrl->InsertColumn(3,L".",LVCFMT_LEFT,50);
	//pmyListCtrl->InsertColumn(4,L".",LVCFMT_LEFT,50);
	//pmyListCtrl->InsertColumn(5,L".",LVCFMT_LEFT,50);
	
	
	/**************************/
	pmyListCtrl->SetExtendedStyle(pmyListCtrl->GetExtendedStyle()|LVS_EX_GRIDLINES |LVS_EX_FULLROWSELECT );
	return 0;
}

void CtispdDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	OnOK();
}

int CtispdDlg::InsertStr(void)
{/*
CListCtrl* pmyListCtrl=&List;
int nCount = pmyListCtrl->GetItemCount();

// Delete all of the items from the list view control.
for (int i=0;i < nCount;i++)
{
   pmyListCtrl->DeleteItem(0);
}
// Insert  items in the list view control.

int i=0;
CString strText;
for(int i=0;i<maxuserscount;i++)
{
	if(Users[i].UserName_0.IsEmpty())
		continue;
strText = Users[i].UserName_0;
   // Insert the item, select every other item.
   pmyListCtrl->InsertItem(
      LVIF_TEXT|LVIF_STATE, i , strText, 
     0, LVIS_SELECTED,
      0, 0);

   // Initialize the text of the subitems.
   

/*
  	  strText.Format(TEXT("%g"), ptask->obj[i].hobj);
      pmyListCtrl->SetItemText(i, 2, strText);

  	  strText.Format(TEXT("%g"), ptask->obj[i].inten);
      pmyListCtrl->SetItemText(i, 3, strText);

	  pmyListCtrl->SetItem(i, 0, LVIF_STATE, NULL, 0, LVIS_SELECTED, 
		LVIS_SELECTED, 0);

		/*
  CListCtrl* pmyListCtrl=&listObjCtrl;
 //pmyListCtrl->DeleteAllItems( );


CString strText;
	
// Insert  items in the list view control.
int i=num;
//for (int i=0;i < ptask->nobj;i++)
{
    strText.Format(TEXT("%d"), i+1);

   // Insert the item, select every other item.
   pmyListCtrl->InsertItem(
      LVIF_TEXT|LVIF_STATE, i, strText, 
     0, LVIS_SELECTED,
      0, 0);

   // Initialize the text of the subitems.
   

	
	  strText.Format(TEXT("%g"), ptask->obj[i].lobj);
      pmyListCtrl->SetItemText(i, 1, strText);

  	  strText.Format(TEXT("%g"), ptask->obj[i].hobj);
      pmyListCtrl->SetItemText(i, 2, strText);

  	  strText.Format(TEXT("%g"), ptask->obj[i].inten);
      pmyListCtrl->SetItemText(i, 3, strText);

	  pmyListCtrl->SetItem(i, 0, LVIF_STATE, NULL, 0, LVIS_SELECTED, 
		LVIS_SELECTED, 0);
 
}*/
	return 0;
}

int CtispdDlg::CreateSliders(void)
{
RECT rect = {0,0,0,0};
if(pSliders)
delete[]pSliders;
pSliders = new CProgressCtrl[maxuserscount];		
CListCtrl* pmyListCtrl=&List;
	for(int i=0;i<maxuserscount;i++)
	{
		pSliders[i].Create(PBS_SMOOTH |   WS_CHILD/* | WS_BORDER*/ ,rect,pmyListCtrl,i);
	pSliders[i].SetRange(0,100);
	pSliders[i].SetPos(0);
	//pSliders[i].ShowWindow(SW_SHOW);
	}
	ResizeProgress();
	return 0;
}

void CtispdDlg::OnBnClickedButton2()
{
	/*if(m_nTimer!=-1)
	{
		KillTimer(m_nTimer);
		m_nTimer=-1;
	}*/
	int oldgrid = SDlg.gridsize;
	CPropertySheet pSh(L" TIspd");
	pSh.AddPage(&SDlg);
	pSh.AddPage(&SptPg);
	if(pSh.DoModal()==IDOK)
	{
		
	if(SDlg.speedkbytes)
	{
		kbytes = 8.0;
		speedval="/";
	}
	else
	{
		kbytes = 1.0;
		speedval="/";
	}

	Srv.IP_24 = SDlg.ServerName;
	Srv.RXSPDContract = SDlg.dmaxin;
	Srv.TXSPDContract = SDlg.dmaxout;
		
		//		if(maxuserscount!=SDlg.maxuserscount)
	//	maxuserscount = SDlg.maxuserscount;
/*		if(pTrafInspAdmin!=NULL)
			pTrafInspAdmin.Release();
*/		CreateUsers();
		CreateSliders();
		//CListCtrlCol* pmyListCtrl=&List;
		//for(int i=0; i<maxuserscount;i++)
		//	pmyListCtrl->SetStyle(i,USEROFFLINE);
		if(oldgrid!=SDlg.gridsize)
		{
			ResizeGrid();
		}
		hWnd = GetSafeHwnd();

		//ConectTI((LPVOID*)this);
			

	}

}

void CtispdDlg::OnHdnTrackList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMHEADER phdr = reinterpret_cast<LPNMHEADER>(pNMHDR);
	// TODO: Add your control notification handler code herep
/*	


		CListCtrl* pmyListCtrl=&List;
	LV_COLUMNW lcolumn;
	int x=0, cx=0;
	RECT rect;
	int i;
	int nstr=1;
	int vstr=20;
	int nCol;
	for(i=0;i<SLIDER;i++)
	{
	cx+=pmyListCtrl->GetColumnWidth(i);
   	}
	rect.left=cx;
	rect.right = cx+pmyListCtrl->GetColumnWidth(i);
	rect.top=nstr*vstr;
	rect.bottom=(nstr+1)*vstr;
	pSliders[0].MoveWindow(&rect);*/
	*pResult = 0;
}

void CtispdDlg::OnHdnItemchangingList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMHEADER phdr = reinterpret_cast<LPNMHEADER>(pNMHDR);
	//ResizeProgress();
	*pResult = 0;
}

void CtispdDlg::OnHdnItemchangedList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMHEADER phdr = reinterpret_cast<LPNMHEADER>(pNMHDR);
	Invalidate();
	ResizeProgress();
	*pResult = 0;
}

void CtispdDlg::OnNMReleasedcaptureList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	//	ResizeProgress();

	*pResult = 0;
}

int CtispdDlg::ResizeProgress(void)
{
	CListCtrl* pmyListCtrl=&List;
//	LV_COLUMNW lcolumn;
	int x=0, cx=0;
	RECT rect;
	RECT rectItem;
	int i;
	int nstr=1;
//	vstr = 16;
//	int nCol;

	// vstr = rect.bottom-rect.top;
CString text;
pmyListCtrl->GetItemRect(0, &rectItem, LVIR_BOUNDS);
cx = rectItem.left;
	for(i=0;i<SLIDER;i++)
	{
	cx+=pmyListCtrl->GetColumnWidth(i);
   	}

	rect.left=cx+2;
	rect.right =cx+pmyListCtrl->GetColumnWidth(i)-2;
	for(nstr=0;nstr<maxuserscount;nstr++)
	{
	pmyListCtrl->GetItemRect(nstr, &rectItem, LVIR_BOUNDS);
	rect.top=rectItem.top+2;//(nstr+1)*(vstr)+5;
	rect.bottom=rectItem.bottom-2;//(rectItem.top+rectItem.bottom) / 2; //(nstr+2)*vstr-5;
	pSliders[nstr].MoveWindow(&rect);
	text = pmyListCtrl->GetItemText(nstr,0);
	if(text.IsEmpty() || text == Srv.UserName_0)
	{
		pSliders[nstr].ShowWindow(SW_HIDE);
	}
	else
	{
	pSliders[nstr].ShowWindow(SW_SHOW);
//	pSliders[nstr].Invalidate(TRUE);
	//pSliders[nstr].SetPos(PersentRXSPD);

	}
	}

	pmyListCtrl->Invalidate();	
	return 0;
}

int CtispdDlg::CreateUsers(void)
{
//if(Users)
//{
//	delete[]Users;
//	Users=NULL;
//}
//Users = new CTiUserData [maxuserscount];
ConnectToTiSrv();
	return 0;
}

int CtispdDlg::ConnectToTiSrv(void)
{
	return 0;
}
LRESULT CtispdDlg::UsersUpdated(WPARAM wParam, LPARAM lParam)
{
	if(!IsWindow(m_hWnd))
		return -1;
	//	CreateUsers();
		ReCalcSumktraff();
		CreateSliders();
	//	UpdateList();
		CListCtrlCol* pmyListCtrl=&List;
	/*	for(int i=0; i<maxuserscount;i++)
			pmyListCtrl->SetStyle(i,USEROFFLINE);
			*/
				ResizeGrid();
	
	

	return 0;
}
 LRESULT CtispdDlg::ReciveData(WPARAM wParam, LPARAM lParam)
{
//HRESULT hr;
//double maxcurin=0.0;
//double maxcurout=0.0;
//
//if(pTrafInspAdmin==NULL)
//{
//	AfxMessageBox(L" !");
//	if(m_nTimer!=-1)
//	{
//		KillTimer(m_nTimer);
//		m_nTimer==-1;
//	}
//	return -1;
//IID_TrafInspAdmin = __uuidof(ITrafInspAdmin);
//CLSIDFromProgID(L"TrafInsp.TrafInspAdmin", &CLSID_TrafInsp);//	 CLSID   ProgID
//COSERVERINFO csServerInfo = {0L, SDlg.ServerName.GetBuffer(0), 0, 0};
//MULTI_QI mqResults = {&IID_TrafInspAdmin, NULL, 0};
//hr = CoInitializeEx(NULL, COINIT_MULTITHREADED);
///*if (hr!=S_OK)
//{
//	AfxMessageBox(L"  COM");
//	return 1;
//}*/
//
//hr = CoCreateInstanceEx(CLSID_TrafInsp, NULL, CLSCTX_ALL, &csServerInfo, 1, &mqResults);
//if (hr!=S_OK)
//{
//	AfxMessageBox(L"   " + SDlg.ServerName);
//	return -1;
//}
//pTrafInspAdmin.Attach((ITrafInspAdmin*)mqResults.pItf);
//
//try{
//hr = pTrafInspAdmin->APILogon(SDlg.APIPass.GetBuffer(0));
//} catch(...){
//		AfxMessageBox(L" .     " + SDlg.ServerName);
//		return -1;
////}
//}
//if(m_nTimer==-1)
// m_nTimer = SetTimer(1, SDlg.timemsec,0);
//long downIN = SDlg.dmaxin; //.    
//long downOUT = SDlg.dmaxout;
//int downloaderindex = -1;
//typedef APIObjectType ObjectType;
//APIObjectType val;
//val = (APIObjectType)3;
///**************************************************************************************/
//CString UserID;
//
//for(int i=0; i<maxuserscount;i++)
//{
// maxcurin=0.0;
// maxcurout=0.0;
//UserID = SDlg.UserName[i];
////try{
//	State = pTrafInspAdmin->APIGetUserState(UserID.GetBuffer(0));
///*}
//catch(...){
//		CloseSession();
//		AfxMessageBox(L"     \"" + SDlg.UserName[i]+"\"   ");
//		return -1;
//}
//*/
///*HRESULT h = SafeArrayLock(State.parray);
//h = SafeArrayPtrOfIndex(
//State.parray, x, ppvData );
//
//h = SafeArrayUnlock(State.parray);
//
//*/
////tagVARIANT HUGEP *pbstr;
//
//	hr = SafeArrayAccessData(State.parray, (void HUGEP**)&UserStat);
//	Users[i].UserName_0 = UserStat[0].bstrVal;
//	Users[i].Active_10 = UserStat[10].lVal;
//	long double r20,t21;
//		if(UserStat[20].vt == VT_R8)
//		r20 = UserStat[20].dblVal;
//	else
//		r20 = UserStat[20].lVal;
//if(UserStat[21].vt == VT_R8)
//		t21 = UserStat[21].dblVal;
//	else
//		t21 = UserStat[21].lVal;
//
//		
//	if(Users[i].RX_20 > 0.0)
//	{  //      ()
//		maxcurin = ((r20 - Users[i].RX_20)/((double)SDlg.timemsec/1000.0*1024.0))*8.0; 
//	}
//if(Users[i].TX_21 > 0.0)
//	{  //      ()
//		maxcurout = ((double)(t21 - Users[i].TX_21)/((double)SDlg.timemsec/1000.0*1024.0))*8.0; 
//	}
//
//	Users[i].RX_20 = r20;
//	Users[i].TX_21 = t21;
//	Users[i].RXSPD_33 = (double)(UserStat[33].lVal*8.0)/1024.0;
//	Users[i].TXSPD_34 = (double)(UserStat[34].lVal*8.0)/1024.0;
//SafeArrayUnaccessData(State.parray);
//if(Users[i].Active_10==0)
//	continue; // 
//
////VARIANT val;
////val.intVal=3;
//
//Users[i].TXSPDContract = pTrafInspAdmin->APIGetAttr(val, Users[i].UserName_0.GetBuffer(0), "User_OutBandwidth");
//Users[i].RXSPDContract = pTrafInspAdmin->APIGetAttr(val, Users[i].UserName_0.GetBuffer(0), "User_InBandwidth");
//if(Users[i].UserName_0!=SDlg.Downloader)
//{
//	downIN = downIN - Users[i].RXSPDContract;
//	downOUT = downOUT - Users[i].TXSPDContract;
//}
//else
//	downloaderindex = i;
//
// Users[i].AvgRX=maxcurin;
// Users[i].AvgTX=maxcurout;
//if(Users[i].RXSPD_33 > maxcurin)
//	maxcurin = Users[i].RXSPD_33;
//
//
//if(Users[i].TXSPD_34 > maxcurout)
//maxcurout = Users[i].TXSPD_34;
//
//Users[i].PersentRXSPD = (maxcurin/Users[i].RXSPDContract)*100.0;
//Users[i].PersentTXSPD = (maxcurout/Users[i].TXSPDContract)*100.0;
////		Users[i].Active_10 = a->lVal;
////tagSAFEARRAY b = pv[10];
//}
//
//if((downloaderindex >=0) && (SDlg.autospeed))//    
//{
//	
//	if((downIN<0)||(downOUT<0))
//	{// !
//		downIN=0;
//		downOUT=0;
//	}
//	
//	{
//	if(Users[downloaderindex].RXSPDContract!=downIN)
//		pTrafInspAdmin->APISetAttr(val, SDlg.Downloader.GetBuffer(0), "User_InBandwidth", downIN ,TRUE);
//	if(Users[downloaderindex].TXSPDContract!=downOUT)
//		pTrafInspAdmin->APISetAttr(val, SDlg.Downloader.GetBuffer(0), "User_OutBandwidth", downOUT ,TRUE);
//	}
//
//}
//_variant_t x = State.GetAddress();
UpdateList();

	return 0;
}

int CtispdDlg::UpdateList(void)
{
	if(hide)
	{
		ShowWindow(SW_MINIMIZE);
		ShowWindow(SW_HIDE);
		hide=0;
	}
	if(isonline==GOAWAY)
	{
		return -1;
	}
	if(Users.IsEmpty())
		return -1;
	COLORREF RowColor[2]={RGB(0,0,0),RGB(100,100,100)};
	if(SDlg.speedkbytes)
	{
		kbytes = 8.0;
		speedval="/";
	}
	else
	{
		kbytes = 1.0;
		speedval="/";
	}

//InsertStr();
CListCtrlStyled* pmyListCtrl=&List;	
CString strText;
LVFINDINFO FindInfo;
FindInfo.flags = LVFI_STRING;
int index;
int needresize = 0;
//int nRow=-1;
for(int i=0; i<maxuserscount;i++)
{
	//nRow++;
	if(Users[i].UserName_0.IsEmpty())
		continue;
	FindInfo.psz = Users[i].UserName_0;

	index = pmyListCtrl->FindItem(&FindInfo);
	if(index!=-1)
	pmyListCtrl->SetItemData(index, i);
	
	if((Users[i].Active_10==0)&& (index!=-1))
	{
		if(!ShowNoAct)
		{
			DeleteFromList(index);
			needresize = 1;
			//nRow--;
			continue;
		}
	}
	else
		if((index==-1))
		{
			if ((Users[i].Active_10==0) && (!ShowNoAct))
				continue;
		index = pmyListCtrl->InsertItem(LVIF_TEXT|LVIF_STATE, 0 , Users[i].UserName_0, 
						0, LVIS_SELECTED, 0, 0);
		pmyListCtrl->SetItemData(index, i);
									
			if(index==-1)
			{
				AfxMessageBox(L"Error add to list ");
			continue;
			}
    		needresize = 1;
		}
		if(index==-1)
			continue;
		strText.Format(L"%.1f/%.1f",(double)Users[i].RXSPDContract/kbytes,(double)Users[i].TXSPDContract/kbytes);
		pmyListCtrl->SetItemText(index,CONTRACTSPDRXTX ,strText);
		// RXMB
		strText.Format(L"%5.3f",(double)(Users[i].RX_20)/1024.00/1024.00);
		pmyListCtrl->SetItemText(index,RXMB ,strText);
		// TXMB
		strText.Format(L"%5.3f",(double)(Users[i].TX_21)/1024.00/1024.00);
		pmyListCtrl->SetItemText(index,TXMB ,strText);
		pSliders[index].SetPos(Users[i].PersentRXSPD);


		strText.Format(L"%.1f/%.1f",(double)Users[i].AvgRX/kbytes,(double)Users[i].AvgTX/kbytes);
		pmyListCtrl->SetItemText(index,AVGRXTX ,strText);

//RXTXSPD
		strText.Format(L"%.1f/%.1f",(double)Users[i].RXSPD_33/kbytes,(double)Users[i].TXSPD_34/kbytes);
		pmyListCtrl->SetItemText(index,RXTXSPD ,strText);

		
		strText.Format(L"%02d.%02d.%02d %d:%02d:%02d",Users[i].lastacttime.wDay,Users[i].lastacttime.wMonth,
		Users[i].lastacttime.wYear,Users[i].lastacttime.wHour,Users[i].lastacttime.wMinute,
		Users[i].lastacttime.wSecond);
		pmyListCtrl->SetItemText(index,LASTACTIVE ,strText);
		if(sumktraff==0.0)
			sumktraff=1;
		strText.Format(L"%.2f",Users[i].ktraff);
		pmyListCtrl->SetItemText(index,KTRAFF ,strText);
		
		Groups.GetGroupNamebyId(Users[i].groupid,strText);
		pmyListCtrl->SetItemText(index,GROUPNAME ,strText);
			if((Users[i].LimitMaxInkbit>0) ||(Users[i].LimitMaxOutkbit>0))
			{
			if(Users[i].LimitMaxInkbit>0)
					strText.Format(L"%.1f/",Users[i].LimitMaxInkbit/kbytes);
			else
					strText=L"-/";
			CString str2;
			if(Users[i].LimitMaxOutkbit>0)
					str2.Format(L"%.1f",Users[i].LimitMaxOutkbit/kbytes);
			else
					str2=L"-";
			strText=strText+str2;
						
			pmyListCtrl->SetItemText(index,MAXSPEEDLIMIT ,strText);
			

			}
			else
				pmyListCtrl->SetItemText(index,MAXSPEEDLIMIT ,L"");

		pmyListCtrl->SetItemText(index,USERIP ,Users[i].IP_24);
		strText.Format(L"%.3f",Users[i].Balance_19);
		pmyListCtrl->SetItemText(index,USER_BALANCE ,strText);


}
//if(needresize)
		//for(int i=0; i<List.GetItemCount();i++)
	pmyListCtrl->SortItems(SortFunc, (LPARAM)this);
	for(int i=0; i<maxuserscount;i++)
	{
		//nRow++;
		if(Users[i].UserName_0.IsEmpty())
			continue;
		FindInfo.psz = Users[i].UserName_0;
		index = pmyListCtrl->FindItem(&FindInfo);
		if(index!=-1)
		{
			pmyListCtrl->SetItemData(index, i);
			if(isonline & NM_OFFLINE)
				pmyListCtrl->SetStyle(index,OFFLINE);
			else
			{
				switch(Users[i].status){
					case U_ACT:
						pmyListCtrl->SetStyle(index,STANDARD);
						break;
					case U_ICQ:
						pmyListCtrl->SetStyle(index,ICQUSER);
						break;
				case U_SLEEP:
					pmyListCtrl->SetStyle(index,USERSLEEP);
					break;
				case U_OFFLINE:
					pmyListCtrl->SetStyle(index,USEROFFLINE);
					break;

				}
			}
		
		}
	}
	

//****// Server //******//
	FindInfo.psz = Srv.UserName_0;

	index = pmyListCtrl->FindItem(&FindInfo);

	if((index==-1))
	{
		index = pmyListCtrl->InsertItem(LVIF_TEXT, pmyListCtrl->GetItemCount() , Srv.UserName_0, 
						0, 0, 0, 0);//|LVIF_STATE
		pmyListCtrl->SetItemData(index, /*pmyListCtrl->GetItemCount() */ 10000);
	}
	if(index!=-1)
	{
		pmyListCtrl->SetItemText(index,USERIP ,SDlg.ServerName);

		strText.Format(L"%.1f/%.1f",(double)Srv.RXSPDContract/kbytes,(double)Srv.TXSPDContract/kbytes);
		pmyListCtrl->SetItemText(index,CONTRACTSPDRXTX ,strText);
		// RXMB
		strText.Format(L"%5.3f",(double)(Srv.RX_20)/1024.00/1024.00);
		pmyListCtrl->SetItemText(index,RXMB ,strText);
		// TXMB
		strText.Format(L"%5.3f",(double)(Srv.TX_21)/1024.00/1024.00);
		pmyListCtrl->SetItemText(index,TXMB ,strText);
		if(SDlg.srvlimittraff)
		{
		strText.Format(L"%5.3f",SDlg.srvlimittraff - (double)(Srv.RX_20)/1024.00/1024.00 -(double)(Srv.TX_21)/1024.00/1024.00);
		pmyListCtrl->SetItemText(index,USER_BALANCE ,strText);
		int col0 = 7;
		int col = col0;
		pmyListCtrl->SetItemText(index, col ,Srv.str[col-col0]);
		col++;
		pmyListCtrl->SetItemText(index, col ,Srv.str[col-col0]);
		col++;
		pmyListCtrl->SetItemText(index, col ,Srv.str[col-col0]);
		col++;
		pmyListCtrl->SetItemText(index, col ,Srv.str[col-col0]);
		col++;
		pmyListCtrl->SetItemText(index, col ,Srv.str[col-col0]);
		col++;
		pmyListCtrl->SetItemText(index, col ,Srv.str[col-col0]);
		col++;
		}

		pmyListCtrl->SetStyle(index,TISRV);

	//	strText.Format(L"%.3f",Users[i].Balance_19);

	}
//***// end //******//

	ResizeProgress();
return 0;
}
/*
for(int i=0;i<maxuserscount;i++)
{
	if(Users[i].UserName_0.IsEmpty())
		continue;
	
	strText.Format(L"111");
	FindInfo.psz = Users[i].UserName_0;
	index = pmyListCtrl->FindItem(&FindInfo);
	if((Users[i].Active_10==0)&& (index!=-1))
	{
		DeleteFromList(index);
		continue;
	}
	else
		if((index==-1) &&(Users[i].Active_10))
		{
			index = AddToList(i);
			if(index==-1)
				AfxMessageBox(L"Error add to list " + Users[i].UserName_0);
		}
	pmyListCtrl->SetItemText(index,1,strText);
	
}
return 0;
}
/*
//InsertStr();
CListCtrl* pmyListCtrl=&List;	
CString strText;
LVFINDINFO FindInfo;
FindInfo.flags = LVFI_STRING;
int index;
for(int i=0;i<maxuserscount;i++)
{
	if(Users[i].UserName_0.IsEmpty())
		continue;
	
	strText.Format(L"111");
	FindInfo.psz = Users[i].UserName_0;
	index = pmyListCtrl->FindItem(&FindInfo);
	if((Users[i].Active_10==0)&& (index!=-1))
	{
		DeleteFromList(index);
		continue;
	}
	else
		if((index==-1) &&(Users[i].Active_10))
		{
			index = AddToList(i);
			if(index==-1)
				AfxMessageBox(L"Error add to list " + Users[i].UserName_0);
		}
	pmyListCtrl->SetItemText(index,1,strText);
	
}
return 0;
*/
int CtispdDlg::DeleteFromList(int i)
{
	CListCtrl* pmyListCtrl=&List;	
	 pmyListCtrl->DeleteItem(i);
	return 0;
}

int CtispdDlg::AddToList(int i)
{
	CString strText;
	CListCtrl* pmyListCtrl=&List;	
	strText = Users[i].UserName_0;
    return pmyListCtrl->InsertItem(
      LVIF_TEXT|LVIF_STATE, 0 , strText, 
     0, LVIS_SELECTED,
      0, 0);
	
}

//void CtispdDlg::OnTimer(UINT_PTR nIDEvent)
//{
//	ReciveData(0,0);
//	CDialog::OnTimer(nIDEvent);
//}

int CtispdDlg::CloseSession(void)
{
	//if(m_nTimer!=-1)
	//{
	//KillTimer(m_nTimer);
	//m_nTimer=-1;
	//}
	//if(pTrafInspAdmin!=NULL)
	//	pTrafInspAdmin.Release();
	return 0;
}

void CtispdDlg::OnLvnEndScrollList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	// This feature requires Internet Explorer 5.5 or greater.
	// The symbol _WIN32_IE must be >= 0x0560.
	LPNMLVSCROLL pStateChanged = reinterpret_cast<LPNMLVSCROLL>(pNMHDR);
	//Invalidate();
	ResizeProgress();
	*pResult = 0;
}

void CtispdDlg::OnSizing(UINT fwSide, LPRECT pRect)
{
	static RECT old;
	
	CDialog::OnSizing(fwSide, pRect);
	if((old.bottom!=pRect->bottom) || (old.right!=pRect->right))
	{
	//	ResizeGrid();
		
		ResizeControls(pRect);
	}
	old = *pRect;
}

int CtispdDlg::ResizeControls(LPRECT pRect)
{
	CListCtrl* pmyListCtrl=&List;	
	RECT rect;
	rect.top=20;
	rect.left=2;
	rect.right=pRect->right-pRect->left-8;
	rect.bottom=pRect->bottom-pRect->top-62;

	/*pmyListCtrl->GetClientRect(&rect);
	rect.right=pRect->right-pRect->left-2;
	rect.bottom=pRect->bottom-pRect->top-100;
	*/
	pmyListCtrl->MoveWindow(&rect);

	RECT rect2;
	rect2.right=rect.right-2;
	rect2.left=rect2.right - (150);
	rect2.top=rect.bottom+2;
	rect2.bottom=rect2.top+26;
	GetDlgItem(IDC_BUTTON2)->MoveWindow(&rect2);

	RECT rect3;
	
	rect3.left=rect2.left-4;
	rect3.right=rect3.left+2;
	rect3.top=rect.bottom+2;
	rect3.bottom=rect2.top+26;
	GetDlgItem(IDC_BUTTON1)->MoveWindow(&rect3);
	
	RECT rect4;
	rect4.left=2;
	rect4.right=rect3.left-4;
	rect4.top=rect.bottom+4;
	rect4.bottom=rect2.top+26;
	GetDlgItem(IDC_COMBOLOG)->MoveWindow(&rect4);

	return 0;
}
class ofstream;
LRESULT CtispdDlg::AddLog(WPARAM wParam, LPARAM lParam)
{

	
	CString * mess= (CString *)lParam;
	int code = (int)wParam;
if(code & NM_PROMPT)
	{
		EditPrompt.SetWindowText(mess->GetBuffer(0));

		CString messtray;
		messtray=L"TIspd:"+*mess;
		lstrcpyn(nid.szTip,messtray, sizeof(nid.szTip)/sizeof(nid.szTip[0]));
		BOOL bSuccess = Shell_NotifyIcon(NIM_MODIFY, &nid);

		return LRESULT();

	}

	CString message;
	  SYSTEMTIME SystemTime;
	GetLocalTime(&SystemTime);
	message.Format(L"%02d.%02d.%02d %d:%02d:%02d",SystemTime.wDay,SystemTime.wMonth,SystemTime.wYear,
		SystemTime.wHour,SystemTime.wMinute,SystemTime.wSecond);

	

//message = 
		//{COMBOERROR,WARNING,CHANGE_PARAM,INFO};
//	#define CRITICAL_ERROR  0
//#define NM_DONE			1
//#define NM_WARNING		2
//#define NM_CHANGE_PARAM 4
//#define NM_INFO			8
int style = INFO;

if(code & CRITICAL_ERROR)
	style = COMBOERROR; else
	if(code & NM_WARNING)
		style = WARNING; else
		if(code & NM_CHANGE_PARAM)
			style = CHANGE_PARAM;
		else
			style = INFO;
	log.AddString(message + " " + (*mess));
	log.SetStyle(log.GetCount()-1,style);
	log.SetCurSel(log.GetCount()-1);
	if(SDlg.maxlog)
	while(log.GetCount()>SDlg.maxlog)
		log.DeleteString(0);

if(SDlg.tispdlog!=L"")
{
	FILE * fp = _wfopen(SDlg.tispdlog.GetBuffer(0),L"a+, ccs=UNICODE");
	if(!fp)
	{		
			
	
   log.AddString(L"  \"" + SDlg.tispdlog + "\"     ");
   SDlg.tispdlog="";
	//return LRESULT();
	}
	else
	{
	CString str = message + " " + (*mess)+"\n";
	_fseek_nolock(fp,0,SEEK_END);
	fputws( str.GetBuffer(0),fp);
	fclose(fp);
	}
   




	//if( fwprintf_s(fp,L"%c",0xFEFF) ==-1){AfxMessageBox(L"   "+filename);return;}
	/*
CFile f;
CFileException e;


if( !f.Open( SDlg.tispdlog, CFile::modeCreate | CFile::modeReadWrite | CFile::modeNoTruncate, &e ) )
   {

   log.AddString(L"  \"" + SDlg.tispdlog + "\"     ");
   SDlg.tispdlog="";
   return LRESULT();
   }
CString str = message + " " + (*mess)+"\n";
f.SeekToEnd();
f.Write(str.GetBuffer(0),sizeof(TCHAR)*str.StringLength(str));
f.Close();
*/
/*
	class ofstream myFile; // Static or on the stack
	myFile.open( SDlg.logfilename );
	if(myFile.is_open())
	{
myFile<<message + " " + (*mess)<<endl;
	}
*/
/*	FILE *flog = _wfopen(SDlg.logfilename.GetBuffer(0),L"a+");
		
	if(!flog)
	{
		return LRESULT();
	}
	fwprintf(flog,L"%s\n",W2CT(message + " " + (*mess)));
	fprintf(flog,"\n"); 
	fclose(flog);
	*/
}
if((code & NM_OFFLINE) || (code & NM_ONLINE) ||( (code & NM_MODE)))
	StatusChanged(code);

	return LRESULT();
}

void CtispdDlg::OnNMDblclkList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	CListCtrl* pmyListCtrl=&List;	
//pmyListCtrl->GetFirstSelectedItemPosition()
	POSITION pos = pmyListCtrl->GetFirstSelectedItemPosition();
if (pos != NULL)
{
  ChangeSpeedDlg();
}
else
{
	HideShowOffline();

}
	
	//*pResult = 0;
}

void CtispdDlg::OnLvnItemchangedList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	// TODO: Add your control notification handler code here
	*pResult = 0;
}

//      ?
int CtispdDlg::CanIncreaseTraffic(int userindex)
{
	if(SDlg.mode==0)
		return 0;
	if(Users[userindex].Active_10==0)
		return 1;
	if(SDlg.useusersleep)
		if(Users[userindex].status ==U_SLEEP)
			return 1;
	return 0;
}

int CtispdDlg::ResizeGrid(void)
{
		RECT rect;
		this->GetWindowRect(&rect);
		rect.bottom=rect.top+105+(vstr-2)*SDlg.gridsize;
		this->MoveWindow(&rect,1);
		ResizeControls(&rect);
	return 0;
}

int CtispdDlg::IsICQUser(int index)
{
	if(Users[index].AvgRX < SDlg.sleeptraff)
		return 1;
	else
		return 0;
}

void CtispdDlg::OnBnClickedButtonShowlog()
{
	
	FILE * fp = _wfopen(SDlg.tispdlog.GetBuffer(0),L"r, ccs=UNICODE");
	//FILE * fp = _wfopen(L"tispd.cfg",L"r, ccs=UNICODE");
	if(!fp)
	{
		AfxMessageBox(L"   "+SDlg.tispdlog);
		return;
	}
	CLogDlg Dlg;
	Dlg.flog = fp;
	Dlg.DoModal();
	fclose(fp);
}

int CtispdDlg::PreInit(int mode)
{
		_wsetlocale(LC_ALL, L"" );
	vstr = 16;
    Stopped.SetEvent();
	CRowStyle styles[MAXSTYLES];
	styles[STANDARD].txtclr=RGB(200,15,200);//GetSysColor( COLOR_WINDOWTEXT );
	styles[STANDARD].bkclr=RGB(245,255,245);//GetSysColor( COLOR_WINDOW );

	styles[USEROFFLINE].txtclr=RGB(100,100,100);
	styles[USEROFFLINE].bkclr=RGB(230,230,230);//=GetSysColor( COLOR_WINDOW );

	styles[USERSLEEP].txtclr=RGB(50,50,200);
	styles[USERSLEEP].bkclr=RGB(240,240,245);//GetSysColor( COLOR_WINDOW );

	styles[ICQUSER].txtclr=RGB(50,150,50);
	styles[ICQUSER].bkclr=RGB(240,250,240);//GetSysColor( COLOR_WINDOW );

	styles[OFFLINE].txtclr=RGB(100,100,100);
	styles[OFFLINE].bkclr=RGB(255,255,255);//=GetSysColor( COLOR_WINDOW );

	styles[TISRV].txtclr=GetSysColor( COLOR_BTNTEXT );//=RGB(0,0,150);
	styles[TISRV].bkclr=GetSysColor( COLOR_BTNFACE );//=RGB(50,50,50);
	//	RGB(50,50,50);//=GetSysColor( COLOR_WINDOW );


	List.InitStyles(styles,MAXSTYLES);

	//{COMBOERROR,WARNING,CHANGE_PARAM,INFO};
	CRowStyle combostyles[4];

	combostyles[COMBOERROR].txtclr=RGB(255,255,255);
	combostyles[COMBOERROR].bkclr=RGB(150,0,0);
	combostyles[WARNING].txtclr=RGB(255,255,255);
	combostyles[WARNING].bkclr=RGB(200,0,150);
	combostyles[CHANGE_PARAM].txtclr=RGB(255,255,255);
	combostyles[CHANGE_PARAM].bkclr=RGB(0,150,150);
	combostyles[INFO].txtclr=RGB(200,255,200);
	combostyles[INFO].bkclr=RGB(0,0,50);
	log.InitStyles(combostyles,4);

	Users.SetSize(1);
	//Users[0].sleeping=0;

		FILE * fp;
	fp =_wfopen(SDlg.filename.GetBuffer(0),L"r, ccs=UNICODE");
	if((fp!=NULL))
	{
		fclose(fp);
		SDlg.OnBnClickedButtonLoadcfg();
		SDlg.firstloading=0;
		SDlg.OnBnClickedOk();
		return TRUE; 
		
	}

	return 0;
}

void CtispdDlg::OnHdnItemclickList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMHEADER phdr = reinterpret_cast<LPNMHEADER>(pNMHDR);
	
	NMLISTVIEW *pLV = (NMLISTVIEW *) pNMHDR;
//List.SortItems(SortFunc, /*pLV->iItem*/);
	SortByCol = pLV->iItem;
	SortWay[SortByCol]=-SortWay[SortByCol];
	List.SortItems(SortFunc, (LPARAM) this);
	UpdateList();
	*pResult = 0;
}

void CtispdDlg::OnBnClickedButtonAddusersfromti()
{
		
		TICmd.command = TI_GETUSERS;
		GetFromTI();
}

int CtispdDlg::Adduser(CString& username)
{
	for(int i=0;i<maxuserscount;i++)
		if(Users[i].UserName_0 == username)
		return 0;

	if(Users.GetSize()<=maxuserscount+1)
			Users.SetSize(Users.GetSize()+5);
		Users[maxuserscount].UserName_0 = username;
		maxuserscount++;
if(IsWindow(m_hWnd))
SendMessage(WM_USERSUPDATED,0,0);
//SDlg.maxuserscount=maxuserscount;
	/*	CreateUsers();
		CreateSliders();
		CListCtrlCol* pmyListCtrl=&List;
		for(int i=0; i<maxuserscount;i++)
			pmyListCtrl->SetStyle(i,USEROFFLINE);
				ResizeGrid();
				*/
	


	return maxuserscount-1;
}

void CtispdDlg::OnBnClickedButtonConnect()
{

	Srv.IP_24 = SDlg.ServerName;
	Srv.RXSPDContract = SDlg.dmaxin;
	Srv.TXSPDContract = SDlg.dmaxout;


		hWnd = GetSafeHwnd();
		UsersUpdated(0,0);
		Break.ResetEvent();
		ChangeSpeedlim.ResetEvent();
		AfxBeginThread((AFX_THREADPROC)ConectTI,(LPVOID*)this );
}

void CtispdDlg::OnNMRclickList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	
	CWnd* pWnd = CWnd::FromHandlePermanent(pNMHDR->hwndFrom);
 //     CControlBar* pBar = DYNAMIC_DOWNCAST(CControlBar, pWnd);

   //     if (pBar != NULL)
		{
			POINT pt;
			 GetCursorPos(&pt);
			CMenu Menu; 
			    LPNMITEMACTIVATE lpnmitem = (LPNMITEMACTIVATE) pResult;
  //		  pt.x = LOWORD(pResult);
//            pt.y = HIWORD(pResult);


			int count;
			 //GetMouseMovePoints(&pt, 1,&count);
		
	 if (Menu.LoadMenu(IDR_LISTMENU))
            {
                CMenu* pSubMenu = Menu.GetSubMenu(0);

                if (pSubMenu!=NULL)
                {
					pSubMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,pt.x,pt.y,this);
                }
            }
		}

	*pResult = 0;
}

void CtispdDlg::OnRButtonDown(UINT nFlags, CPoint point)
{
	
	CDialog::OnRButtonDown(nFlags, point);
}

afx_msg void CtispdDlg::DeleteUser(void)
{
	CListCtrlCol *pmyListCtrl = &List;
	POSITION pos = pmyListCtrl->GetFirstSelectedItemPosition();
if (pos != NULL)
{
   while (pos)
   {
      int nItem =  pmyListCtrl->GetNextSelectedItem(pos);
      TRACE1("Item %d was selected!\n", nItem);
	  CString UserName;
	   UserName = pmyListCtrl->GetItemText(nItem,0);
	   if(UserName.IsEmpty())
		   break;
	   //if((WaitForSingleObject(ChangeSpeedlim,0)==WAIT_OBJECT_0))   
			 //{
				// MessageLog(CString(L" .  "),hWnd);
				// break;
			 //}
	   
		
	   for(int i=0; i<maxuserscount;i++)
	   {
		   if(Users[i].UserName_0 == UserName)
		   {
			  DeleteFromList(nItem);
			  ResizeProgress();
			  maxuserscount--;
			  Users.RemoveAt(i);
			 // UsersUpdated(0,0);
			  UpdateList();
			  ReCalcSumktraff();
			 break;
		   }
	   }
      
   }

}
	return;
}

void CtispdDlg::OnLvnKeydownList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLVKEYDOWN pLVKeyDow = reinterpret_cast<LPNMLVKEYDOWN>(pNMHDR);
	if((pLVKeyDow->wVKey==46)&&(pLVKeyDow->flags==339))// TODO: Add your control notification handler code here
		DeleteUser();
	*pResult = 0;
}

void CtispdDlg::ChangeSpeedDlg()
{
		CListCtrl* pmyListCtrl=&List;	
//pmyListCtrl->GetFirstSelectedItemPosition()
	POSITION pos = pmyListCtrl->GetFirstSelectedItemPosition();
if (pos != NULL)
{
   while (pos)
   {
      int nItem =  pmyListCtrl->GetNextSelectedItem(pos);
      TRACE1("Item %d was selected!\n", nItem);
	  CString UserName;
	   UserName = pmyListCtrl->GetItemText(nItem,0);
	   if(UserName.IsEmpty())
		   break;
	   //if((WaitForSingleObject(ChangeSpeedlim,0)==WAIT_OBJECT_0))   
			 //{
				// MessageLog(CString(L" .  "),hWnd);
				// break;
			 //}
	   for(int i=0; i<maxuserscount;i++)
	   {
		   if(Users[i].UserName_0 == UserName)
		   {
			   CChgSpd SpdDlg;
			   CChgSpd *lDlg = &SpdDlg;
			   lDlg->rx=lDlg->nrx=Users[i].RXSPDContract;
			   lDlg->tx=lDlg->ntx=Users[i].TXSPDContract;
			   //lDlg->UserCombo.AddString(UserName);
			   //lDlg->UserCombo.SetCurSel(0);
			   lDlg->UserName=UserName;
			   lDlg->m_ktraff = Users[i].ktraff;
			   lDlg->maxInLimit = Users[i].LimitMaxInkbit;
			   lDlg->maxOutLimit = Users[i].LimitMaxOutkbit;
			   if(lDlg->DoModal()==IDOK)
			   {
				   if((lDlg->rx!=lDlg->nrx)||(lDlg->tx!=lDlg->ntx))
				   {
						Users[i].NewRXSpeed = lDlg->nrx;
						Users[i].NewTXSpeed = lDlg->ntx;
						ChangeSpeedlim.SetEvent();
				   }
				   if(lDlg->m_ktraff != Users[i].ktraff)
				   {
					   Users[i].ktraff = lDlg->m_ktraff;
					   ReCalcSumktraff();
				   }
				Users[i].LimitMaxInkbit=lDlg->maxInLimit;
				Users[i].LimitMaxOutkbit=lDlg->maxOutLimit;
			   }
			   //Users[i].NewRXSpeed=
			   //Users[i].NewTXSpeed=
			   break;
		   }
	

	   }
      
   }

}
}
void CtispdDlg::OnBnClickedButtonLogoff()
{
	
//if(WaitForSingleObject(pTfread,10)==WAIT_OBJECT_0)
if(WaitForSingleObject(Stopped,200)==WAIT_TIMEOUT)
//if(MsgWaitForMultipleObjectsEx(1,&Stopped,0,0,0)==WAIT_TIMEOUT)

	{
		Break.SetEvent();
		MessageLog(CString("  ..."),hWnd,NM_INFO);
		
		/*WaitForSingleObject(Stopped,INFINITE);
		MessageLog(CString(" ."),hWnd,NM_INFO);
		Stopped.ResetEvent();
				Break.ResetEvent();*/
	}
else
Stopped.SetEvent();
}

int CtispdDlg::StatusChanged(int code)
{
	
	if(!(code & NM_MODE))
	{
	if(isonline==GOAWAY)
		SendMessage(WM_CLOSE,0,0);
		isonline = code;
	}

	if(isonline & NM_ONLINE)
	{
		this->SetWindowTextW(L"TIspd -   "+SDlg.ServerName);

		CString messtray;
		messtray=L"TIspd -   "+SDlg.ServerName;
		lstrcpyn(nid.szTip,messtray, sizeof(nid.szTip)/sizeof(nid.szTip[0]));
		if(SDlg.mode)
		nid.hIcon = ::LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_MAINFRAME)); //      , ? IDR_MAINFRAME
		else
		nid.hIcon = ::LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_ICONRD)); //      , ? IDR_MAINFRAME
		BOOL bSuccess = Shell_NotifyIcon(NIM_MODIFY, &nid);
		
	}
	if(isonline & NM_OFFLINE)
	{
		this->SetWindowTextW(L"TIspd - ");
		CString messtray;
		messtray=L"TIspd - ";
		lstrcpyn(nid.szTip,messtray, sizeof(nid.szTip)/sizeof(nid.szTip[0]));
		nid.hIcon = ::LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_ICONOFF)); //      , ? IDR_MAINFRAME
		BOOL bSuccess = Shell_NotifyIcon(NIM_MODIFY, &nid);

		UpdateList();

	}
	

	return 0;
}

void CtispdDlg::AddUserToList(void)
{

	CAddUserDlg AddDlg;
	if(AddDlg.DoModal()==IDOK)
	{
		if(AddDlg.newuser!="")
			if(!Adduser(AddDlg.newuser))
				AfxMessageBox(AddDlg.newuser+ L"    ");
			else
				UsersUpdated(0, 0);
	}
	return ;
}

BOOL CtispdDlg::DestroyWindow()
{
	
	return CDialog::DestroyWindow();
}

void CtispdDlg::OnClose()
{
	
	if(WaitForSingleObject(Stopped,20)==WAIT_TIMEOUT)
	{
		
		if(isonline!=GOAWAY)
		{
			isonline=GOAWAY;
			OnBnClickedButtonLogoff();
			
		}
		else
		CDialog::OnClose();
	}
	else
		CDialog::OnClose();
	BOOL bSuccess = Shell_NotifyIcon(NIM_DELETE, &nid);
	DestroyIcon(nid.hIcon);

}

afx_msg void CtispdDlg::HideShowOffline(void)
{

	ShowNoAct=1-ShowNoAct;
	UpdateList();
//	List.SortItems(SortFunc, (LPARAM)this);
//	UpdateList();
	
	return;
}

void CtispdDlg::SaveSettings(void)
{
	SDlg.OnBnClickedButtonSavecfg();
	return ;
}

afx_msg void CtispdDlg::LoadSettings(void)
{
	SDlg.OnBnClickedButtonLoadcfg();
	return;
}

afx_msg void CtispdDlg::Quit(void)
{
	SendMessage(WM_CLOSE,0,0);
	return afx_msg void();
}

int CtispdDlg::CreateIcon(void)
{
	HINSTANCE hInstance;
	memset(&nid, 0, sizeof(nid)); nid.cbSize = sizeof(nid);
	nid.hWnd = m_hWnd; //    
	nid.uID = 1234; //   (,    ,    )
	//nid.hIcon = ::LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_ICON2)); //      , ? IDR_MAINFRAME
	nid.hIcon = ::LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_ICONOFF)); //      , ? IDR_MAINFRAME
	lstrcpyn(nid.szTip, L"TIspd", sizeof(nid.szTip)/sizeof(nid.szTip[0]));

	nid.uFlags = NIF_ICON | NIF_TIP |NIF_MESSAGE;
	nid.uCallbackMessage = WM_TRAYICON;
	BOOL bSuccess = Shell_NotifyIcon(NIM_ADD, &nid);

	return 0;
}
LRESULT CtispdDlg::OnTrayIconEvent(WPARAM wParam, LPARAM lParam)
//LRESULT CtispdDlg::OnTrayIconEvent(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	if(wParam == 1234)
    {
        switch((UINT)lParam)
        {
        case WM_MOUSEMOVE:     return OnIcon_MouseMove();

        case WM_LBUTTONDOWN:   return OnIcon_LeftButtonDown();
        case WM_LBUTTONUP:     return OnIcon_LeftButtonUp();
        case WM_LBUTTONDBLCLK: return OnIcon_LeftButtonDoubleClick();

        case WM_RBUTTONDOWN:   return OnIcon_RightButtonDown();
        case WM_RBUTTONUP:     return OnIcon_RightButtonUp();
        case WM_RBUTTONDBLCLK: return OnIcon_RightButtonDoubleClick();

        case WM_CONTEXTMENU:   return OnIcon_ContextMenu();
             //   5  
        }
    }
	return 0;
}

LRESULT  CtispdDlg::OnIcon_MouseMove()
{
	return 0;
}
LRESULT  CtispdDlg::OnIcon_LeftButtonDown()
{
	OnIcon_LeftButtonDoubleClick();
	return 0;
}
LRESULT  CtispdDlg::OnIcon_LeftButtonUp()
{
	return 0;
}
LRESULT  CtispdDlg::OnIcon_LeftButtonDoubleClick()
{
	ShowWindowDlg();
	/*
	BN_CLICKED idButton = (int)LOWORD(wParam);
  hwndButton = (HWND) lParam;
	*/
	return 0;
}
LRESULT  CtispdDlg::OnIcon_RightButtonDown()
{
	HMENU hMenu = ::LoadMenu(AfxGetInstanceHandle(),
                             MAKEINTRESOURCE(IDR_LISTMENU_TRAY));
    if(!hMenu)  return FALSE;
    HMENU hPopup = ::GetSubMenu(hMenu, 0);
    if(!hPopup) return FALSE;

    SetForegroundWindow();

    POINT pt;
    ::GetCursorPos(&pt);
    BOOL bOK = ::TrackPopupMenu(hPopup, 0, pt.x, pt.y, 0, hWnd, NULL);

    ::DestroyMenu(hMenu);
    return bOK;
	
}
LRESULT  CtispdDlg::OnIcon_RightButtonUp()
{
	return 0;
}
LRESULT  CtispdDlg::OnIcon_RightButtonDoubleClick()
{
	return 0;
}
LRESULT  CtispdDlg::OnIcon_ContextMenu()
{
	return 0;
}
afx_msg void CtispdDlg::ShowWindowDlg(void)
{
	if(IsWindowVisible())
	{
	ShowWindow(SW_MINIMIZE);
	ShowWindow(SW_HIDE);
	}
	else
	{
	ShowWindow(SW_SHOW);
	ShowWindow(SW_RESTORE);
	}
	return afx_msg void();
}

afx_msg void CtispdDlg::ChangeModeRD(void)
{
	SDlg.mode = 0;
	return afx_msg void();
}

afx_msg void CtispdDlg::ChangeModeDiv(void)
{
	SDlg.mode = 3;
	return afx_msg void();
	
}

void CAboutDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	OnOK();
}

int CtispdDlg::ReCalcSumktraff(void)
{
	//sumktraff = 0.0f;
	//for(int i=0;i<maxuserscount;i++)
	//	sumktraff+=Users[i].ktraff;
	return 0;
}

int CtispdDlg::GetFromTI(void)
{
	hWnd = GetSafeHwnd();
		Break.ResetEvent();
		ChangeSpeedlim.ResetEvent();
		AfxBeginThread((AFX_THREADPROC)GetUsersFromTI,(LPVOID*)this );
	return 0;
}

void CtispdDlg::OnBnClickedButtonGetgroupsfromti()
{
	TICmd.command = TI_GETGROUPS;
	GetFromTI();
	CalcUsCountInGr();
}

void CtispdDlg::OnBnClickedButtonGroups()
{
	CalcUsCountInGr();
	GrDlg.DoModal();
	UpdateList();
}

int CtispdDlg::CalcUsCountInGr(void)
{
	for(int i=0;i<Groups.countgroups;i++)
	{
		Groups.GroupList[i].countusers=0;
	}
	for(int i=0;i<maxuserscount;i++)
	Groups.GroupList[Groups.GetIndexbyId(Users[i].groupid)].countusers++;
	return 0;
}

int CtispdDlg::GetMaxGrChanal(int id,int chanal)//        .  
{
	long maxspeed=Groups.GetInBand(id)*chanal;
	long maxlimitedspeed=0;
		
	for(int i=0;i<maxuserscount;i++)
	{
		if(Users[i].groupid==id)
			if(Users[i].status == U_ACT)
			{
				if(Users[i].LimitMaxInkbit<=0)
				{
					maxlimitedspeed  = maxspeed;
					break;
				}
				else
					maxlimitedspeed+=Users[i].LimitMaxInkbit;
			}
	}
	if(maxlimitedspeed<maxspeed)
		maxspeed = maxlimitedspeed;
	return maxspeed;
}

afx_msg void CtispdDlg::OnAbout(void)
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();

	return;
}

void CtispdDlg::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CDialog::OnShowWindow(bShow, nStatus);

	// TODO: Add your message handler code here
}

void CtispdDlg::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized)
{
	CDialog::OnActivate(nState, pWndOther, bMinimized);
	ResizeGrid();
}

BOOL CtispdDlg::PreCreateWindow(CREATESTRUCT& cs)
{


	return CDialog::PreCreateWindow(cs);
}
 int compareZK( const void *arg1, const void *arg2 )
{
double res;
CTiUserData *pUs1 = ((USindex*)arg1)->pUser;
CTiUserData *pUs2 = ((USindex*)arg2)->pUser;

	if((pUs1->LimitMaxInkbit<=0) && (pUs2->LimitMaxInkbit<=0))
		res = 0.0;
	else
	if(pUs1->LimitMaxInkbit<=0) 
		res = 1.0;
	else
	if(pUs2->LimitMaxInkbit<=0) 
		res = -1.0;
	else
		if((pUs1->ktraff!=0.0) && (pUs2->ktraff!=0.0))
		{
		res = ((double)pUs1->LimitMaxInkbit/(double)pUs1->ktraff) - ((double)pUs2->LimitMaxInkbit/(double)pUs2->ktraff);
		}
		else
		res = (double)pUs1->LimitMaxInkbit - (double)pUs2->LimitMaxInkbit;
if(res<0)
	return -1;
if(res>0)
	return 1;
	
return 0;

	
}

int CtispdDlg::SortUsers(void)
{
	Checkuindex();
		qsort(uindex,uindexsize,sizeof(uindex[0]),&compareZK);
	return 0;
}

int CtispdDlg::DeleteUindex(void)
{
	if(uindex!=NULL)
	{
		delete [] uindex;
		uindex=NULL;
	}
	return 0;
}

int CtispdDlg::Checkuindex(void)
{
if (uindexsize<maxuserscount)
	{
		DeleteUindex();
		uindexsize = maxuserscount;
		uindex = new USindex[maxuserscount];
		for(int i=0;i<uindexsize;i++)
		{
			uindex[i].index = i;
			uindex[i].pUser = &Users[i];
		}
	}
return 1;
}
