// ChgSpd.cpp : implementation file
//

#include "stdafx.h"
#include "tispd.h"
#include "ChgSpd.h"


// CChgSpd dialog

IMPLEMENT_DYNAMIC(CChgSpd, CDialog)

CChgSpd::CChgSpd(CWnd* pParent /*=NULL*/)
	: CDialog(CChgSpd::IDD, pParent)
	, rx(0)
	, nrx(0)
	, tx(0)
	, ntx(0)
	, UserName(_T(""))
	, m_ktraff(0)
	, maxInLimit(0)
	, maxOutLimit(0)
{

}

CChgSpd::~CChgSpd()
{
}

void CChgSpd::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_USER, UserCombo);
	DDX_Text(pDX, IDC_EDIT_RX, rx);
	DDX_Text(pDX, IDC_EDIT_NRX, nrx);
	DDX_Text(pDX, IDC_EDIT_TX, tx);
	DDX_Text(pDX, IDC_EDIT_NTX, ntx);
	DDX_Text(pDX, IDC_EDIT1, UserName);
	DDX_Text(pDX, IDC_EDIT_KTRAF, m_ktraff);
	DDV_MinMaxDouble(pDX, m_ktraff, 0, 1000000);
	DDX_Text(pDX, IDC_EDIT_MAXIN, maxInLimit);
	DDX_Text(pDX, IDC_EDIT_MAXOUT, maxOutLimit);
}


BEGIN_MESSAGE_MAP(CChgSpd, CDialog)
	ON_BN_CLICKED(IDOK, &CChgSpd::OnBnClickedOk)
END_MESSAGE_MAP()


// CChgSpd message handlers

BOOL CChgSpd::OnInitDialog()
{
	CDialog::OnInitDialog();
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CChgSpd::OnBnClickedOk()
{
	UpdateData(TRUE);
	OnOK();
}
