#pragma once
#include "afxcmn.h"


// CGroupsDlg dialog

class CGroupsDlg : public CDialog
{
	DECLARE_DYNAMIC(CGroupsDlg)

public:
	CString grName;
	double grchanalin;
	CDialog* pTIDlg;
	CGroupsDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CGroupsDlg();

// Dialog Data
	enum { IDD = IDD_DIALOG_GROUPS };
	enum {GR_ID, GR_NAME,GR_MAXIN,GR_CUSERS,GR_SUMK};

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	CListCtrl ListGroups;
void InitList(void)
{
	CListCtrl* pmyListCtrl=&ListGroups;
	pmyListCtrl->DeleteAllItems();
	int nColumnCount = pmyListCtrl->GetHeaderCtrl()->GetItemCount();
	for (int c=nColumnCount-1;c >= 0;c--)
	{
		pmyListCtrl->DeleteColumn(c);
	}
	
	pmyListCtrl->InsertColumn(GR_ID,L".",LVCFMT_LEFT,20);
	pmyListCtrl->SetExtendedStyle(pmyListCtrl->GetExtendedStyle()|LVS_EX_GRIDLINES |LVS_EX_FULLROWSELECT );
    pmyListCtrl->InsertColumn(GR_NAME,L"",LVCFMT_LEFT,100);
	pmyListCtrl->SetExtendedStyle(pmyListCtrl->GetExtendedStyle()|LVS_EX_GRIDLINES |LVS_EX_FULLROWSELECT );
	pmyListCtrl->InsertColumn(GR_MAXIN,L"  ",LVCFMT_LEFT,150);
	pmyListCtrl->SetExtendedStyle(pmyListCtrl->GetExtendedStyle()|LVS_EX_GRIDLINES |LVS_EX_FULLROWSELECT );
	pmyListCtrl->InsertColumn(GR_CUSERS,L"- .",LVCFMT_LEFT,110);
	pmyListCtrl->SetExtendedStyle(pmyListCtrl->GetExtendedStyle()|LVS_EX_GRIDLINES |LVS_EX_FULLROWSELECT );
	pmyListCtrl->InsertColumn(GR_SUMK,L"..",LVCFMT_LEFT,110);
	pmyListCtrl->SetExtendedStyle(pmyListCtrl->GetExtendedStyle()|LVS_EX_GRIDLINES |LVS_EX_FULLROWSELECT );

	pmyListCtrl=&ListUsersNoGr;
	pmyListCtrl->DeleteAllItems();
	nColumnCount = pmyListCtrl->GetHeaderCtrl()->GetItemCount();
	for (int c=nColumnCount-1;c >= 0;c--)
	{
		pmyListCtrl->DeleteColumn(c);
	}
	pmyListCtrl->InsertColumn(0,L"  ",LVCFMT_LEFT,150);
	pmyListCtrl->SetExtendedStyle(pmyListCtrl->GetExtendedStyle()|LVS_EX_GRIDLINES |LVS_EX_FULLROWSELECT );
	pmyListCtrl->InsertColumn(1,L".",LVCFMT_LEFT,60);
	pmyListCtrl->SetExtendedStyle(pmyListCtrl->GetExtendedStyle()|LVS_EX_GRIDLINES |LVS_EX_FULLROWSELECT );

	pmyListCtrl=&ListUsersInGr;
	pmyListCtrl->DeleteAllItems();
	 nColumnCount = pmyListCtrl->GetHeaderCtrl()->GetItemCount();
	for (int c=nColumnCount-1;c >= 0;c--)
	{
		pmyListCtrl->DeleteColumn(c);
	}
	pmyListCtrl->InsertColumn(0,L" ",LVCFMT_LEFT,150);
	pmyListCtrl->SetExtendedStyle(pmyListCtrl->GetExtendedStyle()|LVS_EX_GRIDLINES |LVS_EX_FULLROWSELECT );
	pmyListCtrl->InsertColumn(1,L".",LVCFMT_LEFT,60);
	pmyListCtrl->SetExtendedStyle(pmyListCtrl->GetExtendedStyle()|LVS_EX_GRIDLINES |LVS_EX_FULLROWSELECT );
    
	return;
}
public:
	virtual BOOL OnInitDialog();
public:
	int ShowGroups(void);
public:
	afx_msg void OnPaint();
public:
	afx_msg void OnBnClickedButtonChangegr();
public:
	afx_msg void OnLvnItemchangedListGroups(NMHDR *pNMHDR, LRESULT *pResult);
public:
	CListCtrl ListNoGroupsUsers;
public:
	afx_msg void OnBnClickedButtonAddusertogroup();
public:
	CListCtrl ListUsersNoGr;
public:
	CListCtrl ListUsersInGr;
public:
	int ShowGroupDetails(void);
public:
	afx_msg void OnBnClickedButtonAddusertogroup2();
public:
	afx_msg void OnBnClickedButtonDelgr();
public:
	afx_msg void OnBnClickedButtonGetgrfromti();
};
