// LogDlg.cpp : implementation file
//

#include "stdafx.h"
#include "tispd.h"
#include "LogDlg.h"
#include "TispdDlg.h"

// CLogDlg dialog

IMPLEMENT_DYNAMIC(CLogDlg, CDialog)

CLogDlg::CLogDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLogDlg::IDD, pParent)
{
	flog=NULL;

}

CLogDlg::~CLogDlg()
{
}

void CLogDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_LOG, List);
}


BEGIN_MESSAGE_MAP(CLogDlg, CDialog)
	ON_WM_PAINT()
END_MESSAGE_MAP()


// CLogDlg message handlers

BOOL CLogDlg::OnInitDialog()
{

	CDialog::OnInitDialog();

		CRowStyle styles[4];
	styles[STANDARD].txtclr=RGB(0,0,200);//GetSysColor( COLOR_WINDOWTEXT );
	styles[STANDARD].bkclr=RGB(245,245,245);//GetSysColor( COLOR_WINDOW );

	styles[USEROFFLINE].txtclr=RGB(100,100,100);
	styles[USEROFFLINE].bkclr=RGB(230,230,230);//=GetSysColor( COLOR_WINDOW );

	styles[USERSLEEP].txtclr=RGB(50,50,200);
	styles[USERSLEEP].bkclr=RGB(240,240,245);//GetSysColor( COLOR_WINDOW );

	styles[ICQUSER].txtclr=RGB(0,200,0);
	styles[ICQUSER].bkclr=RGB(245,255,245);//GetSysColor( COLOR_WINDOW );

	List.InitStyles(styles,4);
	InitList();
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CLogDlg::InitList(void)
{
	CListCtrl* pmyListCtrl=&List;
	
	pmyListCtrl->DeleteAllItems();
	int nColumnCount = pmyListCtrl->GetHeaderCtrl()->GetItemCount();
	for (int c=nColumnCount-1;c >= 0;c--)
	{
		pmyListCtrl->DeleteColumn(c);
	}
//# define CURSPDRX 1 
//# define CURSPDTX 2
//# define SLIDER   3
	pmyListCtrl->InsertColumn(USERNAME,L"",LVCFMT_LEFT,650);
	pmyListCtrl->SetExtendedStyle(pmyListCtrl->GetExtendedStyle()|LVS_EX_GRIDLINES |LVS_EX_FULLROWSELECT );
	return;
}

void CLogDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	if(!feof(flog))
	{
		readnext();
	}

}

int CLogDlg::readnext(void)
{
	int max=2;
	int i=0;
	CListCtrlCol *pmyListCtrl= &List;
	wchar_t str[255];
	while(flog)
	{
		if(feof(flog))
			break;

		if(!fgetws( str,254,flog)) 
			   break;
		str[wcslen(str)-1]=NULL;
		int index = pmyListCtrl->InsertItem(LVIF_TEXT|LVIF_STATE, 0 , str, 
						0, LVIS_SELECTED, 0, 0);
		i++;
		if(i>=max)
			break;
	}
	Invalidate();
	return 0;
}
