// SettDlg.cpp : implementation file
//

#include "stdafx.h"
#include "tispd.h"
#include "TispdDlg.h"
#include "SettDlg.h"


// CSettDlg dialog

IMPLEMENT_DYNAMIC(CSettDlg, CPropertyPage)

CSettDlg::CSettDlg()
	//: CDialog(CSettDlg::IDD, pParent)
	: CPropertyPage(CSettDlg::IDD)
	, ServerName(L"192.168.0.1")
	, APIPass(L"12345")
	, dmaxin(256)
	, dmaxout(64)
	, Downloader(L"")
	, timemsec(1500)
	//, autospeed(TRUE)
	, firstloading(1)
	, mode(0)
	, usersleeptimeout(20)
	, useusersleep(TRUE)
	, autologin(FALSE)
	, startmin(FALSE)
	, tispdlog(_T("TIspd.log"))
	, maxlog(50)
	, gridsize(4)
	, minRXchanal(64)
	, tzamer(2)
	, timezamer(10)
	, useautochanal(FALSE)
	, CorrectRX(1)
	, sleeptraff(0)
	, speedkbytes(FALSE)
	, usemaxspeedlimit(TRUE)
	, beforequit(2)
	, usefreechanal(TRUE)
	, srvlimittraff(0)
{
//	maxuserscount=0;
	filename=L"TIspd.cfg";
	UserName[0]=Downloader;
	
int i=	Downloader.GetLength();
	
}

CSettDlg::~CSettDlg()
{
}

void CSettDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_SRV, ServerName);
	DDX_Text(pDX, IDC_EDIT_PWD, APIPass);
	DDX_Text(pDX, IDC_EDIT_RXMAX, dmaxin);
	DDX_Text(pDX, IDC_EDIT_TXMAX, dmaxout);
	DDX_Text(pDX, IDC_EDIT_DWNUSERNAME, Downloader);
	DDX_Text(pDX, IDC_EDIT_TIMER, timemsec);
	//DDX_Text(pDX, IDC_EDIT_USERNAME, AddUserName);
	//	DDX_Control(pDX, IDC_LIST_USERS, ListUsers);
	//	DDX_Check(pDX, IDC_CHECK_AUTOSPD, autospeed);
	DDX_Radio(pDX, IDC_RADIO_MODE, mode);
	DDX_Text(pDX, IDC_EDIT_TIMEOUTSLEEP, usersleeptimeout);
	DDX_Check(pDX, IDC_CHECK_USESLEEP, useusersleep);
	DDX_Check(pDX, IDC_CHECK_AUTOLOGIN, autologin);
	DDX_Check(pDX, IDC_CHECK_STARTMIN, startmin);
	DDX_Text(pDX, IDC_EDIT_LOGFILE, tispdlog);
	DDX_Text(pDX, IDC_EDIT_MAXLOG, maxlog);
	DDX_Text(pDX, IDC_EDIT_GRIDSIZE, gridsize);
	DDV_MinMaxUInt(pDX, gridsize, 0, 500);
	//	DDX_Control(pDX, IDC_LIST_USERSLIST, List);
	DDX_Text(pDX, IDC_EDIT_RXMIN, minRXchanal);
	//DDX_Text(pDX, IDC_EDIT_PERIODZAMERSPD, tzamer);
	//DDX_Text(pDX, IDC_EDIT_TIMEZAMER, timezamer);
	DDX_Check(pDX, IDC_CHECK_AUTOCHANAL, useautochanal);
	DDX_Text(pDX, IDC_EDIT_CORRECT, CorrectRX);
	DDX_Text(pDX, IDC_EDIT_SLEEPTRAFFIC, sleeptraff);
	DDX_Check(pDX, IDC_CHECK_KBYTES, speedkbytes);
	DDX_Check(pDX, IDC_CHECK_USEMAXLIMIT, usemaxspeedlimit);
	DDX_Radio(pDX, IDC_RADIO_EXIT, beforequit);
	DDX_Check(pDX, IDC_CHECK_USEFREETRAFFIC, usefreechanal);
	DDX_Text(pDX, IDC_EDIT_SRVTRAAFLIMIT, srvlimittraff);
}


BEGIN_MESSAGE_MAP(CSettDlg, CDialog)
//	ON_BN_CLICKED(IDC_BUTTON_ADDUSERNAME, &CSettDlg::OnBnClickedButtonAddusername)
	ON_BN_CLICKED(IDOK, &CSettDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_BUTTON1, &CSettDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON_UNDO, &CSettDlg::OnBnClickedButtonUndo)
	ON_BN_CLICKED(IDC_BUTTON_SAVECFG, &CSettDlg::OnBnClickedButtonSavecfg)
	ON_BN_CLICKED(IDC_BUTTON_LOADCFG, &CSettDlg::OnBnClickedButtonLoadcfg)
//	ON_BN_CLICKED(IDC_BUTTON_DWNLDRNAME, &CSettDlg::OnBnClickedButtonDwnldrname)
	ON_BN_CLICKED(IDC_CHECK_AUTOCHANAL, &CSettDlg::OnBnClickedCheckAutochanal)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_BUTTON_CLEARLOG, &CSettDlg::OnBnClickedButtonClearlog)
END_MESSAGE_MAP()


// CSettDlg message handlers
/*
void CSettDlg::OnBnClickedButtonAddusername()
{
	UpdateData(TRUE);
	CListBox* pMyListBox = &ListUsers;
	if(AddUserName.IsEmpty())
		return;
	pMyListBox->AddString(AddUserName);
	UserName[pMyListBox->GetCount()-1] = AddUserName;
	AddUserName="";
	UpdateData(FALSE);

}
*/
void CSettDlg::OnBnClickedOk()
{
//	CListBox* pMyListBox = &ListUsers;
	if(IsWindow(m_hWnd))
		UpdateData();
//maxuserscount = pMyListBox->GetCount();
//	if(maxuserscount<=0)
//	{
//		AfxMessageBox(L" ,     (  )");
//		return;
//	}
	if(APIPass.IsEmpty())
	{
		AfxMessageBox(L" !");
		return;
	}
	if(ServerName.IsEmpty())
	{
		AfxMessageBox(L"  TI!");
		return;
	}
	if(mode==1)
		if(Downloader.IsEmpty())
		{
			AfxMessageBox(L"  ,    ");
			return;
		}
//CtispdDlg *pDlg = (CtispdDlg*)TiDlg;
	//for(int i=0;i<maxuserscount;i++)
	//{
	//	pMyListBox->GetText(i,UserName[i]);
	//	if(pDlg->Users.GetSize()<=i)
	//		pDlg->Users.SetSize(pDlg->Users.GetSize()+5);
	//	pMyListBox->GetText(i,pDlg->Users[i].UserName_0);
	//}
if(IsWindow(m_hWnd))
	OnOK();
}

BOOL CSettDlg::OnInitDialog()
{

//	List.InitStyles(styles,3);
	
	//=----------------
	CDialog::OnInitDialog();
//	InitList();
//	CListBox* pMyListBox = &ListUsers;
//	pMyListBox->ResetContent();
	//FILE * fp;
	//fp =_wfopen(filename.GetBuffer(0),L"r, ccs=UNICODE");
	//if((firstloading) &&(fp!=NULL))
	//{
	//	
	//	fclose(fp);
	//	OnBnClickedButtonLoadcfg();
	//	firstloading=0;
	//	if(autologin)
	//		OnBnClickedOk();
	//	return TRUE; 
	//	
	//}
	//else
	{
/*	firstloading=0;
	for(int i=0; i<maxuserscount;i++)
	pMyListBox->AddString(UserName[i]);
	*/
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CSettDlg::OnBnClickedButton1()
{
//	CListBox* pMyListBox = &ListUsers;
//	pMyListBox->DeleteString(pMyListBox->GetCurSel());
}

void CSettDlg::OnBnClickedButtonUndo()
{
	UpdateData(FALSE);
}

void CSettDlg::OnBnClickedButtonSavecfg()
{
	if(IsWindow(m_hWnd))
	if(UpdateData()==FALSE)
		return;
	CtispdDlg* pDlg = (CtispdDlg*)TiDlg;

	FILE * fp = _wfopen(filename.GetBuffer(0),L"w, ccs=UNICODE");
	if(!fp)
	{
		
		AfxMessageBox(L"   "+filename);
		return;
	}
	//if( fwprintf_s(fp,L"%c",0xFEFF) ==-1){AfxMessageBox(L"   "+filename);return;}
	CString str;
	//if( fwprintf_s(fp)==-1){AfxmessageBox("   "+filename);return;}
	if( fwprintf_s(fp,L"%s %d\n",L"SrvLimTraff_MB:", srvlimittraff) ==-1){AfxMessageBox(L"   "+filename);return;}
	if( fwprintf_s(fp,L"%s %d\n",L"SpeedLimTraff_Mode:", pDlg->SptPg.trafflimmode) ==-1){AfxMessageBox(L"   "+filename);return;}
	if( fwprintf_s(fp,L"%s %d\n",L"SpeedLimTraff_SefeTraff:", pDlg->SptPg.safetraff) ==-1){AfxMessageBox(L"   "+filename);return;}
	if( fwprintf_s(fp,L"%s %d\n",L"SpeedLimTraff_MaxTraff:", pDlg->SptPg.maxtraff) ==-1){AfxMessageBox(L"   "+filename);return;}
	if( fwprintf_s(fp,L"%s %.4f\n",L"SpeedLimTraff_StartKoeff:", pDlg->SptPg.startkoeff) ==-1){AfxMessageBox(L"   "+filename);return;}
	if( fwprintf_s(fp,L"%s %.4f\n",L"SpeedLimTraff_EndKoeff:", pDlg->SptPg.endktraff) ==-1){AfxMessageBox(L"   "+filename);return;}
	if( fwprintf_s(fp,L"%s %d\n",L"SpeedLimTraff_DnoLimitKbits:", pDlg->SptPg.dnomaxkbits) ==-1){AfxMessageBox(L"   "+filename);return;}

	if( fwprintf_s(fp,L"%s %d\n",L"BeforeQuit:", (int)beforequit) ==-1){AfxMessageBox(L"   "+filename);return;}
	if( fwprintf_s(fp,L"%s %d\n",L"UserMAXSpeedLimits:", (int)usemaxspeedlimit) ==-1){AfxMessageBox(L"   "+filename);return;}
	if( fwprintf_s(fp,L"%s %d\n",L"ReUseFreeChanal:", pDlg->SDlg.usefreechanal) ==-1){AfxMessageBox(L"   "+filename);return;}
	if( fwprintf_s(fp,L"%s %d\n",L"DisplaySpeed_in_kBytes_s:", speedkbytes) ==-1){AfxMessageBox(L"   "+filename);return;}
	if(useautochanal)
	if( fwprintf_s(fp,L"%s %d\n",L"UseAutoChanalWithCorrection:", CorrectRX) ==-1){AfxMessageBox(L"   "+filename);return;}
	if( fwprintf_s(fp,L"%s %d\n",L"AutoZamer_minRXchanal:", minRXchanal) ==-1){AfxMessageBox(L"   "+filename);return;}
	
	if( fwprintf_s(fp,L"%s %d\n",L"UserSleepTraffic:", sleeptraff) ==-1){AfxMessageBox(L"   "+filename);return;}
	if(tispdlog!="")
	if( fwprintf_s(fp,L"%s %s\n",L"LogFileName:", tispdlog.GetBuffer(0))==-1){AfxMessageBox(L"   "+filename);return;}
	if( fwprintf_s(fp,L"%s %d\n",L"LogMaxSize:", maxlog)==-1){AfxMessageBox(L"   "+filename);return;}
	if( fwprintf_s(fp,L"%s %d\n",L"GridSize:", gridsize)==-1){AfxMessageBox(L"   "+filename);return;}

	if( fwprintf_s(fp,L"%s %s\n",L"Server:", ServerName.GetBuffer(0))==-1){AfxMessageBox(L"   "+filename);return;}
	if(autologin)
		if( fwprintf_s(fp,L"%s %s\n",L"AutoLoginPass:", APIPass.GetBuffer(0))==-1){AfxMessageBox(L"   "+filename);return;}
	if( fwprintf_s(fp,L"%s %d\n",L"RefreshTimer_msec:", timemsec)==-1){AfxMessageBox(L"   "+filename);return;}
	if( fwprintf_s(fp,L"%s %d\n",L"TrafficSpeedAutoControll:", mode)==-1){AfxMessageBox(L"   "+filename);return;}
	//if( fwprintf_s(fp,L"%s %s",L"PWD:", APIPass.GetBuffer(0))==-1){AfxMessageBox(L"   "+filename);return;}
	if( fwprintf_s(fp,L"%s %d\n",L"RXMAXkbit:", dmaxin)==-1){AfxMessageBox(L"   "+filename);return;}
	if( fwprintf_s(fp,L"%s %d\n",L"TXMAXkbit:", dmaxout)==-1){AfxMessageBox(L"   "+filename);return;}
	if(!Downloader.IsEmpty())
		if( fwprintf_s(fp,L"%s %s\n",L"DOWNLOADER_USERNAME:", Downloader.GetBuffer(0))==-1){AfxMessageBox(L"   "+filename);return;}
	if( fwprintf_s(fp,L"%s %d\n",L"UserSleep_TimeOut_sec:", usersleeptimeout)==-1){AfxMessageBox(L"   "+filename);return;}
	if( fwprintf_s(fp,L"%s %d\n",L"Use_Sleepers_Traffic:", useusersleep)==-1){AfxMessageBox(L"   "+filename);return;}
	if(startmin)
	if( fwprintf_s(fp,L"%s %d\n",L"StartMinimized:", " TRUE")==-1){AfxMessageBox(L"   "+filename);return;}

	int userscount = pDlg->maxuserscount;
	for(int i=0;i<userscount;i++)
	{
				if( fwprintf_s(fp,L"%s %s\n",L"User:",pDlg->Users[i].UserName_0.GetBuffer(0))==-1){AfxMessageBox(L"   "+filename);return;}
				if( fwprintf_s(fp,L"%s %f\n",L"UserKTraff:",pDlg->Users[i].ktraff)==-1){AfxMessageBox(L"   "+filename);return;}
				if( fwprintf_s(fp,L"%s %d\n",L"UserGrID:",pDlg->Users[i].groupid)==-1){AfxMessageBox(L"   "+filename);return;}
				if( fwprintf_s(fp,L"%s %d\n",L"UserLimitMaxIn:",pDlg->Users[i].LimitMaxInkbit)==-1){AfxMessageBox(L"   "+filename);return;}
				if( fwprintf_s(fp,L"%s %d\n",L"UserLimitMaxOut:",pDlg->Users[i].LimitMaxOutkbit)==-1){AfxMessageBox(L"   "+filename);return;}

	}

	for(int i=1;i<pDlg->Groups.countgroups;i++)
	{
		if( fwprintf_s(fp,L"%s %s\n",L"GroupName:",pDlg->Groups.GroupList[i].GroupName.GetBuffer(0))==-1){AfxMessageBox(L"   "+filename);return;}
		//if( fwprintf_s(fp,L"%s %d\n",L"GroupID:",pDlg->Groups.GroupList[i].id)==-1){AfxMessageBox(L"   "+filename);return;}
		if( fwprintf_s(fp,L"%s %f\n",L"GroupMaxIn:",pDlg->Groups.GroupList[i].Group_InBandwidth)==-1){AfxMessageBox(L"   "+filename);return;}
	}



   fclose(fp);
}

void CSettDlg::OnBnClickedButtonLoadcfg()
{

	CtispdDlg* pDlg = (CtispdDlg*)TiDlg;
	FILE * fp = _wfopen(filename.GetBuffer(0),L"r, ccs=UNICODE");
	if(!fp)
	{
		
		AfxMessageBox(L"   "+filename);
		return;
	}
	//if( fwprintf_s(fp)==-1){AfxmessageBox("   "+filename);return;}
	 wchar_t str[255];
	 int res=1;
	 double grk=1.0;
//	 ListUsers.ResetContent();
	 autologin=FALSE;
	 startmin=FALSE;
	 tispdlog=L"";

    pDlg->maxuserscount=0;
	 int indexuser=-1;
	 int idgr=-1;
	 while(res!=EOF)
	 {
		 res=fwscanf(fp,L"%s",str);
		 CString s=str;
		 if(res==EOF)
			 break;
		 
			 if (s == L"SrvLimTraff_MB:")
		 					{res=fwscanf(fp,L"%d",&srvlimittraff);} else
		 if (s == L"ReUseFreeChanal:")
		 					{res=fwscanf(fp,L"%d",&pDlg->SDlg.usefreechanal);} else
		  if (s == L"BeforeQuit:")
		 					{res=fwscanf(fp,L"%d",&beforequit);} else
		 if (s == L"UserMAXSpeedLimits:")
		 					{res=fwscanf(fp,L"%d",&usemaxspeedlimit);} else
		 if (s == L"DisplaySpeed_in_kBytes_s:")
		 					{res=fwscanf(fp,L"%d",&speedkbytes);} else
		if (s == L"LogFileName:")
				{res=fwscanf(fp,L"%s",str); tispdlog=str;} else
		if (s == L"LogMaxSize:")
				{res=fwscanf(fp,L"%d",&maxlog);} else
		if (s == L"UserSleepTraffic:")
				{res=fwscanf(fp,L"%d",&sleeptraff);} else
		if (s == L"UseAutoChanalWithCorrection:")
			{res=fwscanf(fp,L"%d",&CorrectRX); useautochanal=TRUE;} else
		if (s == L"AutoZamer_minRXchanal:")
			{res=fwscanf(fp,L"%d",&minRXchanal);} else
		if (s == L"Server:")
			{res=fwscanf(fp,L"%s",str); ServerName=str;} else
		if (s == L"AutoLoginPass:")
		{
				fgetws(str,254,fp);
				str[wcslen(str)-1]=NULL;
				CString Str(str);
				Str.Trim();
				APIPass = Str; autologin=TRUE;
				
		}else
		//	{res=fwscanf(fp,L"%s",str); APIPass = str; autologin=TRUE;} else
		if (s == L"RefreshTimer_msec:")
			{res=fwscanf(fp,L"%d",&timemsec);} else
		if (s == L"TrafficSpeedAutoControll:")
			{res=fwscanf(fp,L"%d",&mode);} else
		if (s == L"RXMAXkbit:")
			{res=fwscanf(fp,L"%d",&dmaxin);} else
		if (s == L"TXMAXkbit:")
			{res=fwscanf(fp,L"%d",&dmaxout);} else
		if (s == L"DOWNLOADER_USERNAME:")
			{res=fwscanf(fp,L"%s",str); Downloader=str;} else
		if (s == L"User:")
		{
			
			if(fgetws(str,254,fp) ==NULL) 
				res=EOF;
			else 
			{	str[wcslen(str)-1]=NULL;
				CString Str(str);
				Str.Trim();
				indexuser = pDlg->Adduser(Str);} 
		} else
			if (s == L"UserKTraff:")
				{if(indexuser==-1) AfxMessageBox(L"  "+filename+L" UserKTraff    User ");
				else
				{ double ktr=0.0;
					res=fwscanf(fp,L"%lf",&ktr);
					pDlg->Users[indexuser].ktraff=ktr;}} else
			if (s == L"UserGrID:")
				{if(indexuser==-1) AfxMessageBox(L"  "+filename+L" UserKTraff    User ");
				else
					res=fwscanf(fp,L"%d",&pDlg->Users[indexuser].groupid);} else
			if (s == L"UserLimitMaxIn:")
				{if(indexuser==-1) AfxMessageBox(L"  "+filename+L" UserLimitMaxIn    User ");
				else
					res=fwscanf(fp,L"%d",&pDlg->Users[indexuser].LimitMaxInkbit);} else
			if (s == L"UserLimitMaxOut:")
				{if(indexuser==-1) AfxMessageBox(L"  "+filename+L" UserLimitMaxOut    User ");
				else
					res=fwscanf(fp,L"%d",&pDlg->Users[indexuser].LimitMaxOutkbit);} else
//if( fwprintf_s(fp,L"%s %d\n",L"UserLimitMaxIn:",pDlg->Users[i].LimitMaxInkbit)==-1){AfxMessageBox(L"   "+filename);return;}
//if( fwprintf_s(fp,L"%s %d\n",L"UserLimitMaxOut:",pDlg->Users[i].LimitMaxOutkbit)==-1){AfxMessageBox(L"   "+filename);return;}
//if( fwprintf_s(fp,L"%s %f\n",L"UserGrID:",pDlg->Users[i].groupid)==-1){AfxMessageBox(L"   "+filename);return;}

		if (s == L"UserSleep_TimeOut_sec:")
			{res=fwscanf(fp,L"%d",&usersleeptimeout);} else
		if (s == L"Use_Sleepers_Traffic:")
			{res=fwscanf(fp,L"%d",&useusersleep);} else
		if (s == L"StartMinimized:")
			{res=fwscanf(fp,L"%s",&str); startmin=TRUE;} else
		if (s == L"GridSize:")	
			{res=fwscanf(fp,L"%d",&gridsize);} else
		if (s == L"GroupName:")
		{
			
			if(fgetws(str,254,fp) ==NULL) 
				res=EOF;
			else 
			{	str[wcslen(str)-1]=NULL;
				CString Str(str);
				Str.Trim();
				idgr = pDlg->Groups.AddGroup(Str);} 
		} else
			if (s == L"GroupMaxIn:")
				{if(idgr==-1) AfxMessageBox(L"  "+filename+L" GroupMaxIn    GroupName: ");
				else
				{
					res=fwscanf(fp,L"%lf",&grk);
					pDlg->Groups.SetInBand(idgr,grk);
				}
		}
			else

					if (s == L"SpeedLimTraff_Mode:")	
			{res=fwscanf(fp,L"%d",&pDlg->SptPg.trafflimmode);} else
		if (s == L"SpeedLimTraff_SefeTraff:")	
			{res=fwscanf(fp,L"%d",&pDlg->SptPg.safetraff);} else
		if (s == L"SpeedLimTraff_MaxTraff:")	
			{res=fwscanf(fp,L"%d",&pDlg->SptPg.maxtraff);} else
		if (s == L"SpeedLimTraff_StartKoeff:")	
				{res=fwscanf(fp,L"%lf",&pDlg->SptPg.startkoeff);} else
		if (s == L"SpeedLimTraff_EndKoeff:")	
				{res=fwscanf(fp,L"%lf",& pDlg->SptPg.endktraff);} else
		if (s == L"SpeedLimTraff_DnoLimitKbits:")	
				{res=fwscanf(fp,L"%d",& pDlg->SptPg.dnomaxkbits);} else
								AfxMessageBox(L"  "+filename+L"  : " + str);
	
	 }
	 
	fclose(fp);
	if(IsWindow(m_hWnd))
	{
		UpdateData(FALSE);
	}
	if(IsWindow(pDlg->m_hWnd))
	{

		pDlg->UsersUpdated(0,0);
		pDlg->UpdateList();
	}
	}
	//if( fwprintf_s(fp,L"%s %d\n",L"RefreshTimer_msec:", timemsec)==-1){AfxMessageBox(L"   "+filename);return;}
	//if( fwprintf_s(fp,L"%s %d\n",L"TrafficSpeedAutoControll:", autospeed)==-1){AfxMessageBox(L"   "+filename);return;}
	////if( fwprintf_s(fp,L"%s %s",L"PWD:", APIPass.GetBuffer(0))==-1){AfxMessageBox(L"   "+filename);return;}
	//if( fwprintf_s(fp,L"%s %d\n",L"RXMAXkbit:", dmaxin)==-1){AfxMessageBox(L"   "+filename);return;}
	//if( fwprintf_s(fp,L"%s %d\n",L"TXMAXkbit:", dmaxout)==-1){AfxMessageBox(L"   "+filename);return;}
	//if( fwprintf_s(fp,L"%s %s\n",L"DOWNLOADER_USERNAME:", Downloader.GetBuffer(0))==-1){AfxMessageBox(L"   "+filename);return;}
	//int userscount = ListUsers.GetCount();
	//for(int i=0;i<userscount;i++)
	//{
	//	ListUsers.GetText(i,str);
	//	if( fwprintf_s(fp,L"%s %s\n",L"User:",str.GetBuffer(0))==-1){AfxMessageBox(L"   "+filename);return;}
	//}

/*void CSettDlg::OnBnClickedButtonDwnldrname()
{
	CListBox* pMyListBox = &ListUsers;
	int index = pMyListBox->GetCurSel();
	if(index<0)
		return;
	CString Downl;
	
	pMyListBox->GetText(index,Downl);
	
	UpdateData(TRUE);
	Downloader = Downl;
	UpdateData(FALSE);
	
}
*/
int CSettDlg::IsSleepuser(SYSTEMTIME lastactive)
{
	  SYSTEMTIME SystemTime;
    GetLocalTime(&SystemTime);
	 CTime lasttime(lastactive);
	 CTime tcur = CTime::GetCurrentTime();
	CTime t2 = lasttime + CTimeSpan( 0, 0, 0, usersleeptimeout );    // 1 hour later
	
	if(t2<tcur)
		return 1;
	else
	    return 0;
}

//int CSettDlg::SleepstatusChanged(SYSTEMTIME oldtimeact, SYSTEMTIME newtimeact)
//{
// CTime oldt(oldtimeact)
// CTime newt 
// CTime tcur = CTime::GetCurrentTime();
//
// CTime t2 = lasttime + CTimeSpan( 0, 0, 0, usersleeptimeout );
//	return 0;
//}

/*int CSettDlg::InitList(void)
{
	
	CListCtrl* pmyListCtrl=&List;
	//SelectedItem=-1;
	pmyListCtrl->DeleteAllItems();
	int nColumnCount = pmyListCtrl->GetHeaderCtrl()->GetItemCount();
	for (int c=nColumnCount-1;c >= 0;c--)
	{
		pmyListCtrl->DeleteColumn(c);
	}
//# define CURSPDRX 1 
//# define CURSPDTX 2
//# define SLIDER   3
	pmyListCtrl->InsertColumn(0,L"",LVCFMT_LEFT,75);
	pmyListCtrl->InsertColumn(1,L". RX./",LVCFMT_LEFT,100);
	pmyListCtrl->InsertColumn(2,L". TX./",LVCFMT_LEFT,100);
	pmyListCtrl->InsertColumn(3,L". RX./",LVCFMT_LEFT,100);
	pmyListCtrl->InsertColumn(4,L". TX./",LVCFMT_LEFT,100);
	
	//pmyListCtrl->InsertColumn(3,L".",LVCFMT_LEFT,50);
	//pmyListCtrl->InsertColumn(4,L".",LVCFMT_LEFT,50);
	//pmyListCtrl->InsertColumn(5,L".",LVCFMT_LEFT,50);
	
	

	pmyListCtrl->SetExtendedStyle(pmyListCtrl->GetExtendedStyle()|LVS_EX_GRIDLINES |LVS_EX_FULLROWSELECT );
	
	return 0;
}*/

void CSettDlg::OnBnClickedCheckAutochanal()
{
	UpdateData(TRUE);
	GetDlgItem(IDC_EDIT_CORRECT)->EnableWindow(useautochanal);
		GetDlgItem(IDC_EDIT_RXMIN)->EnableWindow(useautochanal);
}

void CSettDlg::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	// TODO: Add your message handler code here
	// Do not call CDialog::OnPaint() for painting messages
	
	
	
		GetDlgItem(IDC_EDIT_CORRECT)->EnableWindow(useautochanal);
		GetDlgItem(IDC_EDIT_RXMIN)->EnableWindow(useautochanal);
	

}
void MessageLog(CString& mess,HWND hWnd, int Replacelast);
void CSettDlg::OnBnClickedButtonClearlog()
{
FILE * fp = _wfopen(tispdlog.GetBuffer(0),L"w, ccs=UNICODE");
CtispdDlg* pDlg = (CtispdDlg*)TiDlg;
	if(!fp)
	{		
		MessageLog(L"  \"" + tispdlog,pDlg->hWnd, NM_WARNING);
	}
	else
	{
		fclose(fp);	
		MessageLog(tispdlog+L" ",pDlg->hWnd,NM_INFO);
	}

	

}
