// tispdDlg.h : header file
//

#pragma once
#include "TiUserData.h"
#include "GroupsDlg.h"
#include "ListCtrlCol.h"
#include "SettDlg.h"
#include "afxcmn.h"
#include "Group.h"
#include "SpeedTraffPg.h"
enum{USERNAME,USERIP,USER_BALANCE,CONTRACTSPDRXTX,RXMB,TXMB,SLIDER,AVGRXTX,RXTXSPD,LASTACTIVE,KTRAFF,GROUPNAME, MAXSPEEDLIMIT,MAXCOLUMNS};

#define _WIN32_DCOM
//#import "F:\PROGRA~1\TrafInsp\tiregtlb.dll" no_namespace named_guids
enum ListBoxColorTypes {STANDARD,USEROFFLINE,USERSLEEP,ICQUSER,OFFLINE,TISRV,MAXSTYLES};
enum ComboBoxColorTypes {COMBOERROR,WARNING,CHANGE_PARAM,INFO};
#import "progid:TrafInsp.TrafInspAdmin" no_namespace named_guids // 
#include "afxwin.h"
typedef  CListCtrlCol CListCtrlStyled;

#define WM_CONNECTEDOK WM_USER+106
#define WM_MESSLOG WM_USER+107
#define WM_USERSUPDATED WM_USER+108

#define CRITICAL_ERROR  64
#define NM_DONE			1
#define NM_WARNING		2
#define NM_CHANGE_PARAM 4
#define NM_INFO			8
#define NM_OFFLINE		16
#define NM_ONLINE       32
#define NM_PROMPT		256
#define GOAWAY		128

#define TI_GETUSERS 0x01
#define TI_GETGROUPS 0x02
class CCommands{
public:
	CCommands(){
		command=0;
	}
int command;
};
int compareZK( const void *arg1, const void *arg2 );
struct USindex{
	int index;
	CTiUserData *pUser;
};


class CtispdDlg : public CDialog
{
	

// Construction
public:

	 USindex *uindex;
	 CTiSRvData Srv;
	int uindexsize;
	int hide;
	CGroupsDlg GrDlg;
	CSpeedTraffPg SptPg;
	CCommands TICmd;
	NOTIFYICONDATA nid;
	int firststart;
	double kbytes;
	CString speedval;
	int SortWay[MAXCOLUMNS];
	int SortByCol;
	// Sort items by associated lParam
//BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam );
//UINT_PTR   m_nTimer;
HWND hWnd;
int ShowNoAct;

//CComPtr<ITrafInspAdmin> pTrafInspAdmin;

	CtispdDlg(CWnd* pParent = NULL);	// standard constructor
	int vstr;
	CArray <CTiUserData> Users;
	CGroup Groups;
	CSettDlg SDlg;
	virtual ~CtispdDlg()
			{
		if(pSliders)
		{
			delete[]pSliders;
			pSliders=NULL;
		}
		DeleteUindex();
		//if(Users)
		//{
		//	delete[]Users;
		//	Users=NULL;
		//}
	/*	if(pTrafInspAdmin!=NULL)
		pTrafInspAdmin.Release();*/
	}
// Dialog Data
	enum { IDD = IDD_TISPD_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg void ChangeSpeedDlg();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedButton1();
public:
	
	CListCtrlStyled List;
public:
	int InitList(void);
public:
	int SelectedItem;
public:
	afx_msg void OnBnClickedOk();
public:
	int InsertStr(void);
public:
	CProgressCtrl* pSliders;
	// CSliderCtrl* pSliders;
public:
	int CreateSliders(void);
public:
	afx_msg void OnBnClickedButton2();
public:
	afx_msg void OnHdnTrackList1(NMHDR *pNMHDR, LRESULT *pResult);
public:
	afx_msg void OnHdnItemchangingList1(NMHDR *pNMHDR, LRESULT *pResult);
public:
	afx_msg void OnHdnItemchangedList1(NMHDR *pNMHDR, LRESULT *pResult);
public:
	afx_msg void OnNMReleasedcaptureList1(NMHDR *pNMHDR, LRESULT *pResult);
public:
	int ResizeProgress(void);
public:
	int maxuserscount;
public:
	int CreateUsers(void);
public:
	int ConnectToTiSrv(void);
public:
	afx_msg LRESULT ReciveData(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT UsersUpdated(WPARAM wParam, LPARAM lParam);
public:
	int UpdateList(void);
public:
	int DeleteFromList(int i);
public:
	int AddToList(int i);
public:
//	afx_msg void OnTimer(UINT_PTR nIDEvent);
public:
	int CloseSession(void);
public:
	afx_msg void OnLvnEndScrollList1(NMHDR *pNMHDR, LRESULT *pResult);
public:
	afx_msg void OnSizing(UINT fwSide, LPRECT pRect);
public:
	int ResizeControls(LPRECT pRect);
public:
	LRESULT AddLog(WPARAM wParam, LPARAM lParam);
	LRESULT OnTrayIconEvent(WPARAM wParam, LPARAM lParam);
	//LRESULT OnTrayIconEvent(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
public:
	CComboBoxCol log;
public:
	afx_msg void OnNMDblclkList1(NMHDR *pNMHDR, LRESULT *pResult);
public:
	afx_msg void OnLvnItemchangedList1(NMHDR *pNMHDR, LRESULT *pResult);
public:
	//      ?
	int CanIncreaseTraffic(int userindex);
public:
	int ResizeGrid(void);
public:
	CEdit EditPrompt;
public:
	int IsICQUser(int index);
public:
	afx_msg void OnBnClickedButtonShowlog();
public:
	int PreInit(int mode);
public:
	afx_msg void OnHdnItemclickList1(NMHDR *pNMHDR, LRESULT *pResult);
public:
	afx_msg void OnBnClickedButtonAddusersfromti();
public:
	int Adduser(CString& username);
public:
	afx_msg void OnBnClickedButtonConnect();
public:
	afx_msg void OnNMRclickList1(NMHDR *pNMHDR, LRESULT *pResult);
public:
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
public:
	afx_msg void DeleteUser(void);
public:
	afx_msg void OnLvnKeydownList1(NMHDR *pNMHDR, LRESULT *pResult);
public:
	afx_msg void OnBnClickedButtonLogoff();
public:
	int StatusChanged(int code);
public:
	int isonline;
public:
	afx_msg void AddUserToList(void);
public:
	virtual BOOL DestroyWindow();
public:
	afx_msg void OnClose();
public:
	afx_msg void HideShowOffline(void);
public:
	afx_msg void  SaveSettings(void);
public:
	afx_msg void LoadSettings(void);
public:
	afx_msg void Quit(void);
public:
	int CreateIcon(void);

LRESULT  OnIcon_MouseMove();
LRESULT  OnIcon_LeftButtonDown();
LRESULT  OnIcon_LeftButtonUp();
LRESULT  OnIcon_LeftButtonDoubleClick();
LRESULT  OnIcon_RightButtonDown();
LRESULT  OnIcon_RightButtonUp();
LRESULT  OnIcon_RightButtonDoubleClick();
LRESULT  OnIcon_ContextMenu();
public:
	afx_msg void ShowWindowDlg(void);
public:
	afx_msg void ChangeModeRD(void);
public:
	afx_msg void ChangeModeDiv(void);
public:
	float sumktraff;
public:
	int ReCalcSumktraff(void);
public:
	int GetFromTI(void);
public:
	afx_msg void OnBnClickedButtonGetgroupsfromti();
public:
	afx_msg void OnBnClickedButtonGroups();
public:
	int CalcUsCountInGr(void);
public:
	int GetMaxGrChanal(int id,int chanal);//        .  
public:
	afx_msg void OnAbout(void);
public:
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
public:
	afx_msg void OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized);
protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
public:
	int SortUsers(void);
public:
	int DeleteUindex(void);
public:
	int Checkuindex(void);
};
